String.prototype.toFontName = function() {
	var str = this.charAt(0).toUpperCase() + this.slice(1).toLocaleLowerCase();
	return "Fonts/"+str.trim()+".ttf";
}

var UI = {
    Version: 1.00,
	sw : app.GetDisplayWidth(),
	sh : app.GetDisplayHeight(),
	swdp : app.GetDisplayWidth() * (160/ app.GetScreenDensity()),
	shdp : app.GetDisplayHeight() * (160/ app.GetScreenDensity()),
	dp : app.GetScreenDensity(),
	values : {
		input: [],
		layout: [],
		layoutToRemove: null,
		timeOut: null,
		
		listIDs: [],
		lists: [],
		
		IDs: [],
		
		tabIDs: [],
		tabs: [],
		
		objectIDs: [],
		navbars: [],
		dialogs: [],
		menus: [],
		radioSwitchCheckbox: [],
		datePicker: [],
		datePickerID: null,
		timePicker: [],
		months: ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December",]
	},
	functions: {
	    CheckClockTouchAngleHour: function(angle, id) {
	        if( angle > (Math.PI/12) && angle < (Math.PI/4) ) {
	            angle = Math.PI/6;
	            UI.values.timePicker[id].hhText.SetText("02:");
	            UI.values.timePicker[id].chosenTime.hh = "02";
	        }
	        else if(angle > (Math.PI/4) && angle < (5*Math.PI/12)) {
	            angle = Math.PI/3;
	            UI.values.timePicker[id].hhText.SetText("01:");
	            UI.values.timePicker[id].chosenTime.hh = "01";
	        }
	        else if(angle > (5*Math.PI/12) && angle < (7*Math.PI/12)) {
	            angle = Math.PI/2;
	            UI.values.timePicker[id].hhText.SetText("12:");
	            UI.values.timePicker[id].chosenTime.hh = "12";
	        }
	        else if(angle > (7*Math.PI/12) && angle < (9*Math.PI/12)) {
	            angle = 2*Math.PI/3;
	            UI.values.timePicker[id].hhText.SetText("11:");
	            UI.values.timePicker[id].chosenTime.hh = "11";
	        }
	        else if(angle > (9*Math.PI/12) && angle < (11*Math.PI/12)) {
	            angle = 5*Math.PI/6;
	            UI.values.timePicker[id].hhText.SetText("10:");
	            UI.values.timePicker[id].chosenTime.hh = "10";
	        }
	        else if(angle > (11*Math.PI/12) && angle < (13*Math.PI/12)) {
	            angle = Math.PI;
	            UI.values.timePicker[id].hhText.SetText("09:");
	            UI.values.timePicker[id].chosenTime.hh = "09";
	        }
	        else if(angle > (13*Math.PI/12) && angle < (15*Math.PI/12)) {
	            angle = 7*Math.PI/6;
	            UI.values.timePicker[id].hhText.SetText("08:");
	            UI.values.timePicker[id].chosenTime.hh = "08";
	        }
	        else if(angle > (15*Math.PI/12) && angle < (17*Math.PI/12)) {
	            angle = 4*Math.PI/3;
	            UI.values.timePicker[id].hhText.SetText("07:");
	            UI.values.timePicker[id].chosenTime.hh = "07";
	        }
	        else if(angle > (17*Math.PI/12) && angle < (19*Math.PI/12)) {
	            angle = 3*Math.PI/2;
	            UI.values.timePicker[id].hhText.SetText("06:");
	            UI.values.timePicker[id].chosenTime.hh = "06";
	        }
	        else if(angle > (19*Math.PI/12) && angle < (21*Math.PI/12)) {
	            angle = 5*Math.PI/3;
	            UI.values.timePicker[id].hhText.SetText("05:");
	            UI.values.timePicker[id].chosenTime.hh = "05";
	        }
	        else if(angle > (21*Math.PI/12) && angle < (23*Math.PI/12)) {
	            angle = 11*Math.PI/6;
	            UI.values.timePicker[id].hhText.SetText("04:");
	            UI.values.timePicker[id].chosenTime.hh = "04";
	        }
	        else {
	            angle = 0;
	            UI.values.timePicker[id].hhText.SetText("03:");
	            UI.values.timePicker[id].chosenTime.hh = "03";
	        } 
	        return angle;
	    },
	    RenderHour: function(id) {
	        var frontClock = UI.values.timePicker[id].frontClock;
	        var backClock = UI.values.timePicker[id].backClock;
	        backClock.Clear();
	        frontClock.Clear();
	        angle = (93*(Math.PI/180));
            frontClock.DrawText( "12", 0.4875+0.425*Math.cos(angle), 0.5-0.41*Math.sin(angle) );
            angle = (60*(Math.PI/180));
            frontClock.DrawText( "1", 0.4875+0.425*Math.cos(angle), 0.5-0.41*Math.sin(angle) );
            angle = (29*(Math.PI/180));
            frontClock.DrawText( "2", 0.4875+0.425*Math.cos(angle), 0.5-0.41*Math.sin(angle) );
            angle = (358*(Math.PI/180));
            frontClock.DrawText( "3", 0.4875+0.425*Math.cos(angle), 0.5-0.41*Math.sin(angle) );
            angle = (327.5*(Math.PI/180));
            frontClock.DrawText( "4", 0.4875+0.43*Math.cos(angle), 0.5-0.43*Math.sin(angle) );
            angle = (297*(Math.PI/180));
            frontClock.DrawText( "5", 0.4875+0.45*Math.cos(angle), 0.525-0.4*Math.sin(angle) );
            angle = (269.5*(Math.PI/180));
            frontClock.DrawText( "6", 0.4875+0.425*Math.cos(angle), 0.5-0.44*Math.sin(angle) );
            angle = (238*(Math.PI/180));
            frontClock.DrawText( "7", 0.4875+0.42*Math.cos(angle), 0.5-0.46*Math.sin(angle) );
            angle = (212*(Math.PI/180));
            frontClock.DrawText( "8", 0.5+0.455*Math.cos(angle), 0.5-0.425*Math.sin(angle) );
            angle = (180*(Math.PI/180));
            frontClock.DrawText( "9", 0.5+0.45*Math.cos(angle), 0.5125 );
            angle = (153*(Math.PI/180));
            frontClock.DrawText( "10", 0.5+0.455*Math.cos(angle), 0.5-0.425*Math.sin(angle) );
            angle = (123*(Math.PI/180));
            frontClock.DrawText( "11", 0.5+0.455*Math.cos(angle), 0.5-0.425*Math.sin(angle) );
            
            //backClock render
            var hour = UI.values.timePicker[id].chosenTime.hh;
            backClock.SetPaintColor(UI.colors.grey.lighten2);
            backClock.DrawCircle(0.5, 0.5, 0.5);
            backClock.SetPaintColor(UI.values.timePicker[id].color);
            backClock.DrawCircle(0.5, 0.5, 0.0125);
            backClock.SetLineWidth(2);
            var angle = 450 - (hour * (360/12));
	        angle = angle*(Math.PI/180);
	        backClock.DrawLine(0.5, 0.5, 0.5+0.45*Math.cos(angle), 0.5-0.45*Math.sin(angle));
            backClock.DrawCircle(0.5+0.425*Math.cos(angle), 0.5-0.425*Math.sin(angle), 0.07);
            
            frontClock.Update();
            backClock.Update();
	    },
	    RenderMinutes: function(id) {
	        var frontClock = UI.values.timePicker[id].frontClock;
	        var backClock = UI.values.timePicker[id].backClock;
	        backClock.Clear();
	        frontClock.Clear();
	        angle = (92*(Math.PI/180));
            frontClock.DrawText( "0", 0.5+0.4*Math.cos(angle), 0.5-0.41*Math.sin(angle) );
            angle = (60*(Math.PI/180));
            frontClock.DrawText( "5", 0.48+0.425*Math.cos(angle), 0.5-0.41*Math.sin(angle) );
            angle = (29*(Math.PI/180));
            frontClock.DrawText( "10", 0.4875+0.4*Math.cos(angle), 0.5-0.41*Math.sin(angle) );
            angle = (358*(Math.PI/180));
            frontClock.DrawText( "15", 0.495+0.4*Math.cos(angle), 0.5-0.41*Math.sin(angle) );
            angle = (327.5*(Math.PI/180));
            frontClock.DrawText( "20", 0.4875+0.42*Math.cos(angle), 0.5-0.43*Math.sin(angle) );
            angle = (297*(Math.PI/180));
            frontClock.DrawText( "25", 0.4875+0.425*Math.cos(angle), 0.525-0.405*Math.sin(angle) );
            angle = (270*(Math.PI/180));
            frontClock.DrawText( "30", 0.47, 0.5-0.44*Math.sin(angle) );
            angle = (235*(Math.PI/180));
            frontClock.DrawText( "35", 0.49+0.41*Math.cos(angle), 0.5-0.475*Math.sin(angle) );
            angle = (212*(Math.PI/180));
            frontClock.DrawText( "40", 0.5+0.475*Math.cos(angle), 0.5-0.425*Math.sin(angle) );
            angle = (180*(Math.PI/180));
            frontClock.DrawText( "45", 0.5+0.455*Math.cos(angle), 0.515 );
            angle = (153*(Math.PI/180));
            frontClock.DrawText( "50", 0.5+0.45*Math.cos(angle), 0.5-0.425*Math.sin(angle) );
            angle = (123*(Math.PI/180));
            frontClock.DrawText( "55", 0.5+0.45*Math.cos(angle), 0.5-0.42*Math.sin(angle) );
            
            //backClock render
            var minute = UI.values.timePicker[id].chosenTime.mm;
            backClock.SetPaintColor(UI.colors.grey.lighten2);
            backClock.DrawCircle(0.5, 0.5, 0.5);
            backClock.SetPaintColor(UI.values.timePicker[id].color);
            backClock.DrawCircle(0.5, 0.5, 0.0125);
            backClock.SetLineWidth(2);
            var angle = 450 - (minute * (360/60));
	        angle = angle*(Math.PI/180);
	        backClock.DrawLine(0.5, 0.5, 0.5+0.45*Math.cos(angle), 0.5-0.45*Math.sin(angle));
            backClock.DrawCircle(0.5+0.425*Math.cos(angle), 0.5-0.425*Math.sin(angle), 0.07);
    
            frontClock.Update();
            backClock.Update();
	    }
	},
	
	// ===================== COLORS =====================
	darkColors: ["#78909c", "#8d6e63", "#ff7043", "#ffa726", "#ffca28", "#66bb6a", "#26a69a", "#26c6da", "#29b6f6", "#42a5f5", "#5c6bc0", "#7e57c2", "#ab47bc", "#ec407a", "#ef5350", "#e53935", "#d32f2f", "#c62828", "#b71c1c", "#f44336", "#4caf50", "#43a047", "#388e3c", "#2e7d32", "#1b5e20", "#4285F4", "#1e88e5", "#1976d2", "#1565c0", "#0d47a1", "#9e9e9e", "#757575", "#616161", "#424242", "#212121", "#e91e63", "#d81b60", "#c2185b", "#ad1457", "#880e4f", "#9c27b0", "#8e24aa", "#7b1fa2", "#6a1b9a", "#4a148c", "#673ab7", "#5e35b1", "#512da8", "#4527a0", "#311b92", "#3f51b5", "#3949ab", "#303f9f", "#283593", "#1a237e", "#03a9f4", "#039be5", "#0288d1", "#0277bd", "#01579b", "#00bcd4", "#00acc1", "#0097a7", "#00838f", "#006064", "#009688", "#00897b", "#00796b", "#00695c", "#004d40", "#8bc34a", "#7cb342", "#689f38", "#558b2f", "#33691e", "#cddc39", "#c0ca33", "#afb42b", "#9e9d24", "#827717", "#ffeb3b", "#fdd835", "#fbc02d", "#f9a825", "#f57f17", "#ffc107", "#ffb300", "#ffa000", "#ff8f00", "#ff6f00", "#ff9800", "#fb8c00", "#f57c00", "#ef6c00", "#e65100", "#ff5722", "#f4511e", "#e64a19", "#d84315", "#bf360c", "#795548", "#6d4c41", "#5d4037", "#4e342e", "#3e2723", "#607d8b", "#546e7a", "#455a64", "#37474f", "#263238"],
	colors : {
		primary: "#009688",
		secondary: "#ff90a4ae",
		light: "#eeeeee",
		dark: "#3E4551",
		white: "#ffffffff",
		black: "#ff000000",
		transparent: "#00000000",
		red: {
			red: "#f44336",
			lighten1: "#ef5350",
			lighten2: "#e57373",
			lighten3: "#ef9a9a",
			lighten4: "#ffcdd2",
			darken1: "#e53935",
			darken2: "#d32f2f",
			darken3: "#c62828",
			darken4: "#b71c1c",
		},
		green: {
			green: "#4caf50",
			lighten1: "#66bb6a",
			lighten2: "#81c784",
			lighten3: "#a5d6a7",
			lighten4: "#c8e6c9",
			darken1: "#43a047",
			darken2: "#388e3c",
			darken3: "#2e7d32",
			darken4: "#1b5e20",
		},
		blue: {
			blue: "#4285F4",
			lighten1: "#42a5f5",
			lighten2: "#64b5f6",
			lighten3: "#90caf9",
			lighten4: "#bbdefb",
			darken1: "#1e88e5",
			darken2: "#1976d2",
			darken3: "#1565c0",
			darken4: "#0d47a1",
		},
		grey: {
			grey: "#9e9e9e",
			lighten1: "#bdbdbd",
			lighten2: "#e0e0e0",
			lighten3: "#eeeeee",
			lighten4: "#f5f5f5",
			darken1: "#757575",
			darken2: "#616161",
			darken3: "#424242",
			darken4: "#212121",
		},
		pink: {
			pink: "#e91e63",
			lighten1: "#ec407a",
			lighten2: "#f06292",
			lighten3: "#f48fb1",
			lighten4: "#f8bbd0",
			darken1: "#d81b60",
			darken2: "#c2185b",
			darken3: "#ad1457",
			darken4: "#880e4f",
		},
		purple: {
			purple: "#9c27b0",
			lighten1: "#ab47bc",
			lighten2: "#ba68c8",
			lighten3: "#ce93d8",
			lighten4: "#e1bee7",
			darken1: "#8e24aa",
			darken2: "#7b1fa2",
			darken3: "#6a1b9a",
			darken4: "#4a148c",
		},
		deepPurple: {
			deepPurple: "#673ab7",
			lighten1: "#7e57c2",
			lighten2: "#9575cd",
			lighten3: "#b39ddb",
			lighten4: "#d1c4e9",
			darken1: "#5e35b1",
			darken2: "#512da8",
			darken3: "#4527a0",
			darken4: "#311b92",
		},
		indigo: {
			indigo: "#3f51b5",
			lighten1: "#5c6bc0",
			lighten2: "#7986cb",
			lighten3: "#9fa8da",
			lighten4: "#c5cae9",
			darken1: "#3949ab",
			darken2: "#303f9f",
			darken3: "#283593",
			darken4: "#1a237e",
		},
		lightBlue: {
			lightBlue: "#03a9f4",
			lighten1: "#29b6f6",
			lighten2: "#4fc3f7",
			lighten3: "#81d4fa",
			lighten4: "#b3e5fc",
			darken1: "#039be5",
			darken2: "#0288d1",
			darken3: "#0277bd",
			darken4: "#01579b",
		},
		cyan: {
			cyan: "#00bcd4",
			lighten1: "#26c6da",
			lighten2: "#4dd0e1",
			lighten3: "#80deea",
			lighten4: "#b2ebf2",
			darken1: "#00acc1",
			darken2: "#0097a7",
			darken3: "#00838f",
			darken4: "#006064",
		},
		teal: {
			teal: "#009688",
			lighten1: "#26a69a",
			lighten2: "#4db6ac",
			lighten3: "#80cbc4",
			lighten4: "#b2dfdb",
			darken1: "#00897b",
			darken2: "#00796b",
			darken3: "#00695c",
			darken4: "#004d40",
		},
		lightGreen: {
			lightGreen: "#8bc34a",
			lighten1: "#9ccc65",
			lighten2: "#aed581",
			lighten3: "#c5e1a5",
			lighten4: "#dcedc8",
			darken1: "#7cb342",
			darken2: "#689f38",
			darken3: "#558b2f",
			darken4: "#33691e",
		},
		lime: {
			lime: "#cddc39",
			lighten1: "#d4e157",
			lighten2: "#dce775",
			lighten3: "#e6ee9c",
			lighten4: "#f0f4c3",
			darken1: "#c0ca33",
			darken2: "#afb42b",
			darken3: "#9e9d24",
			darken4: "#827717",
		},
		yellow: {
			yellow: "#ffeb3b",
			lighten1: "#ffee58",
			lighten2: "#fff176",
			lighten3: "#fff59d",
			lighten4: "#fff9c4",
			darken1: "#fdd835",
			darken2: "#fbc02d",
			darken3: "#f9a825",
			darken4: "#f57f17",
		},
		amber: {
			amber: "#ffc107",
			lighten1: "#ffca28",
			lighten2: "#ffd54f",
			lighten3: "#ffe082",
			lighten4: "#ffecb3",
			darken1: "#ffb300",
			darken2: "#ffa000",
			darken3: "#ff8f00",
			darken4: "#ff6f00",
		},
		orange: {
			orange: "#ff9800",
			lighten1: "#ffa726",
			lighten2: "#ffb74d",
			lighten3: "#ffcc80",
			lighten4: "#ffe0b2",
			darken1: "#fb8c00",
			darken2: "#f57c00",
			darken3: "#ef6c00",
			darken4: "#e65100",
		},
		deepOrange: {
			deepOrange: "#ff5722",
			lighten1: "#ff7043",
			lighten2: "#ff8a65",
			lighten3: "#ffab91",
			lighten4: "#ffccbc",
			darken1: "#f4511e",
			darken2: "#e64a19",
			darken3: "#d84315",
			darken4: "#bf360c",
		},
		brown: {
			brown: "#795548",
			lighten1: "#8d6e63",
			lighten2: "#a1887f",
			lighten3: "#bcaaa4",
			lighten4: "#d7ccc8",
			darken1: "#6d4c41",
			darken2: "#5d4037",
			darken3: "#4e342e",
			darken4: "#3e2723",
		},
		blueGrey: {
			blueGrey: "#607d8b",
			lighten1: "#78909c",
			lighten2: "#90a4ae",
			lighten3: "#b0bec5",
			lighten4: "#cfd8dc",
			darken1: "#546e7a",
			darken2: "#455a64",
			darken3: "#37474f",
			darken4: "#263238",
		},
	},
	
	// ===================== FONTS =====================
	fonts : {
		thin: "Fonts/Thin.ttf",
		light: "Fonts/Light.ttf",
		regular: "Fonts/Regular.ttf",
		medium:"Fonts/Medium.ttf",
		bold: "Fonts/Bold.ttf",
		icon: "Fonts/Icon.ttf",
	},
	
	// ===================== TEXT =====================
	CreateTextH1: function(text, width, height, options, color, fontweight) {
		fontweight = fontweight || "Regular";
		var txt = app.CreateText(text, width, height, options||"Left");
		txt.SetTextSize(32);
		txt.SetTextColor((color || this.colors.black));
		txt.SetFontFile(fontweight.toFontName());
		return txt;
	},
	CreateTextH2: function(text, width, height, options, color, fontweight) {
		fontweight = fontweight || "Regular";
		var txt = app.CreateText(text, width, height, options||"Left");
		txt.SetTextSize(28);
		txt.SetTextColor((color || this.colors.black));
		txt.SetFontFile(fontweight.toFontName());
		return txt;
	},
	CreateTextH3: function(text, width, height, options, color, fontweight) {
		fontweight = fontweight || "Regular";
		var txt = app.CreateText(text, width, height, options||"Left");
		txt.SetTextSize(25);
		txt.SetTextColor((color || this.colors.black));
		txt.SetFontFile(fontweight.toFontName());
		return txt;
	},
	CreateTextH4: function(text, width, height, options, color, fontweight) {
		fontweight = fontweight || "Regular";
		var txt = app.CreateText(text, width, height, options||"Left");
		txt.SetTextSize(22);
		txt.SetTextColor((color || this.colors.black));
		txt.SetFontFile(fontweight.toFontName());
		return txt;
	},
	CreateTextH5: function(text, width, height, options, color, fontweight) {
		fontweight = fontweight || "Regular";
		var txt = app.CreateText(text, width, height, options||"Left");
		txt.SetTextSize(20);
		txt.SetTextColor((color || this.colors.black));
		txt.SetFontFile(fontweight.toFontName());
		return txt;
	},
	CreateTextH6: function(text, width, height, options, color, fontweight) {
		fontweight = fontweight || "Regular";
		var txt = app.CreateText(text, width, height, options||"Left");
		txt.SetTextSize(18);
		txt.SetTextColor((color || this.colors.black));
		txt.SetFontFile(fontweight.toFontName());
		return txt;
	},
	CreateTextParagraph: function(text, width, height, options, color, fontWeight) {
		fontweight = fontWeight || "Regular";
		var txt = app.CreateText(text, width, height, options+", Multiline"||"Left, Multiline");
		txt.SetTextSize(16);
		txt.SetTextColor(color || this.colors.black);
		txt.SetFontFile(fontweight.toFontName());
		return txt;
	},
	CreateTextSecondary: function(text, width, height, options, color, fontWeight) {
		var txt = app.CreateText(text, width, height, options||"Left");
		txt.SetTextSize(14);
		txt.SetTextColor( color || this.colors.grey.darken1);
		txt.SetFontFile( fontWeight || "Light".toFontName());
		return txt;
	},
	CreateTextJumbo: function(text, width, height, options, color) {
		var txt = app.CreateText(text, width, height, options||"Left");
		txt.SetTextSize(35);
		txt.SetTextColor((color || this.colors.black));
		txt.SetFontFile("Medium".toFontName());
		return txt;
	},
	
	// ===================== BUTTONS =====================
	CreateButtonRaised: function(text, width, height, color, txtcolor) {
		color = color || this.colors.blue.blue;
		var button = app.CreateButton(text, width, height, "Custom, Fontawesome");
		button.SetFontFile(text.search("fa-")>0 ? null : this.fonts.medium);
		button.SetStyle(color, color, 3, 0, 0, 1);
		button.SetTextSize(14);
		button.SetTextColor(txtcolor || "white");
		return button;
	},
	CreateButtonRaisedO: function(text, width, height, color, backColor) {
		var color = color || this.colors.blue.blue;
		var backColor = backColor || "#ffffff";
		var button = app.CreateButton(text, width, height, "Custom, Fontawesome");
		button.SetFontFile(text.search("fa-")>0 ? null : this.fonts.medium);
		button.SetTextColor(color);
		button.SetStyle(backColor, backColor, 2, color, 2, 0);
		button.SetTextSize(14);
		return button;
	},
	CreateButtonRound: function(text, width, height, color, txtcolor) {
		var color = color || this.colors.blue.blue;
		var button = app.CreateButton(text, width, height, "Custom, Fontawesome");
		button.SetFontFile(text.search("fa-")>0 ? null : this.fonts.medium);
		button.SetStyle(color, color, 50, 0, 0, 0.15);
		button.SetTextSize(14);
		button.SetTextColor(txtcolor || "white");
		return button;
	},
	CreateButtonRoundO: function(text, width, height, color, backColor) {
		var color = color || this.colors.blue.blue;
		var backColor = backColor || this.colors.white;
		var button = app.CreateButton(text, -1, -1, "Custom, Fontawesome");
		button.SetSize(width, height);
		button.SetFontFile(text.search("fa-")>0 ? null : this.fonts.medium);
		button.SetTextColor(color);
		button.SetStyle(backColor, backColor, 50, color, 2, 0);
		button.SetTextSize(14);
		return button;
	},
	CreateButtonElegant: function(text, width, height, color) {
		var color = color || this.colors.blue.blue;
		var tr = this.CreateLightColor(color);
		var button = app.CreateButton(text, -1, -1, "Custom, Fontawesome");
		button.SetSize(width, height);
		button.SetFontFile(text.search("fa-")>0 ? null : this.fonts.medium);
		button.SetTextColor(color);
		button.SetStyle(tr, tr, 5, color, 0, 0);
		button.SetTextSize(14);
		return button;
	},
	CreateButtonFlat: function(text, width, height, color, backColor) {
		var color = color || this.colors.blue.blue;
		var backColor = backColor || "#ffffff";
		var button = app.CreateButton(text, width, height, "Custom, Fontawesome");
		button.SetFontFile(text.search("fa-")>0 ? null : this.fonts.medium);
		button.SetTextColor(color);
		button.SetStyle(backColor, backColor, 5, 0, 0, 0);
		button.SetTextSize(14);
		return button;
	},
	CreateFAB: function(icon, color) {
		var color = color || this.colors.blue.blue;
		var button = app.CreateButton(icon.trim(), null, null, "Custom");
    	button.SetSize(65,65, "dp");
    	button.SetFontFile(this.fonts.icon);
    	button.SetStyle(color, color, 50, 0, 0, 0.2);
    	button.SetTextSize(20);
    	button.SetTextColor("white");
    	button.SetPosition(this.Fw(this.swdp-80), this.Fr(this.shdp-135));
    	return button;
	},
	CreateFABOutline: function(icon, color, backColor) {
		var color = color || this.colors.blue.blue;
		var backColor = backColor || this.colors.white;
		var button = app.CreateButton(icon, null, null, "Custom");
		button.SetSize(65, 65, "dp");
		button.SetFontFile(this.fonts.icon);
		button.SetStyle(backColor, backColor, 50, color, 2, 0);
		button.SetTextSize(20);
		button.SetTextColor(color);
		return button;
	},
	CreateFABElegant: function(icon, color) {
		var color = color || this.colors.blue.blue;
		var backColor = this.CreateLightColor(color);
		var button = app.CreateButton(icon, null, null, "Custom");
		button.SetSize(65,65, "dp");
		button.SetFontFile(this.fonts.icon);
		button.SetStyle(backColor, backColor, 50, 0, 0, 0);
		button.SetTextSize(20);
		button.SetTextColor(color);
		return button;
	},
	CreateButtonToggle: function(text, width, height, value, callback, color, backColor) {
	    backColor = backColor || "#ffffff";
	    color = color || this.colors.blue.blue;
	    var button = app.CreateButton(text, width, height, "Custom");
	    button.SetStyle(backColor, backColor, 50, "#e0e0e0", 1, 0);
	    button.SetTextColor(color);
	    button.SetFontFile(this.fonts.regular);
	    UI.values.radioSwitchCheckbox[button.id] = {value: value || false, cb: callback, color: color, backColor: backColor};
	    if(value) {
	        var lightColor = this.CreateLightColor(color);
	        button.SetStyle(lightColor, lightColor, 50, color, 1, 0);
	    }
	    button.SetOnTouch(function() {
	        var value = UI.values.radioSwitchCheckbox[this.id].value;
	        if(!value) {
	            var color = UI.values.radioSwitchCheckbox[this.id].color;
    	        var lightColor = UI.CreateLightColor(color);
    	        this.SetStyle(lightColor, lightColor, 50, color, 1, 0);
    	        UI.values.radioSwitchCheckbox[this.id].value = true;
	        } else {
	            var color = UI.values.radioSwitchCheckbox[this.id].backColor;
    	        this.SetStyle(color, color, 50, "#e0e0e0", 1, 0);
    	        UI.values.radioSwitchCheckbox[this.id].value = false;
	        }
	        var cb = UI.values.radioSwitchCheckbox[this.id].cb;
	        if(cb) cb(UI.values.radioSwitchCheckbox[this.id].value);
	    });
	    return button;
	},
	
	// ======================= INPUTS =====================
	CreateTextEditOutline: function(width, options, hint, boolLabel, color, backColor) {
		color = color || this.colors.blue.blue;
		backColor = backColor || this.colors.white;
		boolLabel = boolLabel || false;
		if(options) options = options.toLowerCase();
		else options = "Left, Singleline";
		
		var radius = options.search("round") > -1 ? 50 : 4;
		var il = app.CreateLayout("Absolute");
		il.SetSize(width, null);
			var bg = app.CreateButton("", null, null, "Custom");
			bg.SetSize( width*this.swdp, 65, "dp" );
			bg.SetStyle("#00000000", "#00000000", radius, "#bdbdbd", 2, 0);
			bg.SetPosition(0, this.Fr(6));
			il.AddChild(bg);
			
			var lbl = app.CreateText(hint);
			lbl.SetFontFile(this.fonts.regular);
			lbl.SetTextColor(color);
			lbl.SetTextSize(12);
			lbl.SetPadding(4, 0, 4, 0, "dp");
			lbl.SetBackColor(backColor);
			lbl.SetPosition(0.048, 0);
			lbl.Hide();
			if(boolLabel != false) {
				options.search("round") > -1 ? lbl.SetPosition(0.075, 0) : null;
				il.AddChild(lbl);
			}
	
			var bnm = app.CreateLayout("Linear", "VCenter, Horizontal, Left");
			bnm.SetSize(width*this.swdp, 65, "dp");
			bnm.SetPosition( 0, 0.008);
				var input = app.CreateTextEdit("", width, null, options+", Singleline");
				input.SetTextColor(this.colors.black);
				input.SetTextSize(16);
				input.SetPadding(0, 8, 0, 8,"dp");
				options.search("round") > -1 ? input.SetPadding(30, -4, 18, 0, "dp") : input.SetPadding(20, -4, 18, 0, "dp");
				input.SetBackColor(this.colors.transparent);
				input.SetCursorColor(this.colors.dark);
				input.SetHint(hint);
				bnm.AddChild(input);
				input.SetOnFocus(function(state) {
					var data = UI.values.input[this.id];
					if(state == true) {
						data.border.SetStyle("#00000000", "#00000000", data.radius, data.color, 2, 0);
						if(data.boolLabel != false) {
							data.label.Show();
							this.SetHint("");
						}
					} else if(!state && this.GetText()=="" ) {
						data.boolLabel ? data.label.Hide() : null;
						this.SetHint(data.hint);
						data.border.SetStyle("#00000000", "#00000000", data.radius, "#bdbdbd", 2, 0);
					}
				});
			il.AddChild(bnm);
			
			this.values.input[input.id] = {
				label: lbl,
				color: color,
				hint: hint,
				border: bg,
				boolLabel: boolLabel,
				radius: radius,
			};
		return {
			Layout: il,
			TextEdit: input,
		};
	},
	CreateTextEditOutlineA: function(width, options, hint, boolLabel, color, backColor) {
		color = color || this.colors.blue.blue;
		backColor = backColor || this.colors.white;
		boolLabel = boolLabel || false;
		options ? options = options.toLowerCase() : options = "Left, Singleline";
		var radius = 4;
		options.search("round") > -1 ? radius = 50 : radius = 4;
		var il = app.CreateLayout("Absolute");
		il.SetSize(width, null);
			var bg = app.CreateButton("", null, null, "Custom");
			bg.SetSize( width*this.swdp, 65, "dp" );
			bg.SetStyle("#00000000", "#00000000", radius, color, 2, 0);
			bg.SetPosition(0, this.Fr(6));
			il.AddChild(bg);
			
			var lbl = app.CreateText(hint);
			lbl.SetFontFile(this.fonts.regular);
			lbl.SetTextColor(color);
			lbl.SetTextSize(12);
			lbl.SetPadding(4, 0, 4, 0, "dp");
			lbl.SetBackColor(backColor);
			lbl.SetPosition(0.048, 0);
			if(boolLabel != false) {
				options.search("round") > -1 ? lbl.SetPosition(0.075, 0) : null;
				il.AddChild(lbl);
				hint = "";
			}
			
			var bnm = app.CreateLayout("Linear", "VCenter, Horizontal, Left");
			bnm.SetSize(width*this.swdp, 65, "dp");
			bnm.SetPosition( 0, 0.008);
				var input = app.CreateTextEdit("", width, null, options+", Singleline");
				input.SetTextColor(this.colors.black);
				input.SetTextSize(16);
				options.search("round") > -1 ? input.SetPadding(30, -4, 18, 0, "dp") : input.SetPadding(20, -4, 18, 0, "dp");
				input.SetBackColor(this.colors.transparent);
				input.SetCursorColor(this.colors.dark);
				input.SetHint(hint);
				bnm.AddChild(input);
			il.AddChild(bnm);

		return {
			Layout: il,
			TextEdit: input,
		};
	},
	CreateTextEditFilled: function(width, options, hint, boolLabel, color) {
		color = color || this.colors.blue.blue;
		boolLabel = boolLabel || false;
		var layout = app.CreateLayout("Linear", "Vertical, Left");
		layout.SetBackColor("#00000000");
				var label = app.CreateText(hint);
				label.SetTextColor(color);
				label.SetTextSize(12);
				label.Hide();
				boolLabel == true ? layout.AddChild(label) : null;
			
				var input = app.CreateTextEdit("", width, null, options+", Singleline");
				input.SetBackColor("#00ffffff");
				input.SetTextColor(this.colors.black);
				input.SetTextSize(16);
				input.SetHint(hint);
				input.SetCursorColor(this.colors.dark);
				input.SetPadding(5, 15, 5, 25, "px");
				input.SetOnFocus(function(state) {
					var data = UI.values.input[this.id];
					if(state) {
						data.border.SetColor(data.color);	
						if(data.boolLabel != false) {
							data.label.Show();
							this.SetHint("");
						}
					} else if(!state && this.GetText()=="" ){
							data.label ? data.label.Hide() : null;
							this.SetHint(data.hint);
							data.border.SetColor("#bdbdbd");
					}
					
				});
				layout.AddChild(input);
			var bottomBorder = app.CreateImage(null, null, null, "fix", 1, 1);
			bottomBorder.SetSize(width*this.sw, 4, "px" );
			bottomBorder.SetColor("#bdbdbd");
			layout.AddChild(bottomBorder);
			this.values.input[input.id] = {
				label: label,
				color: color,
				hint: hint,
				border: bottomBorder,
				type: "material",
				boolLabel: boolLabel,
			};
		return {
			Layout: layout,
			TextEdit: input,
		};
	},
	CreateTextEditFilledA: function(width, options, hint, boolLabel, color) {
		width = width || 1;
		color = color || this.colors.blue.blue;
		var layout = app.CreateLayout("Linear", "Vertical, Left");
		layout.SetBackColor("#00000000");
			var label = app.CreateText(hint);
			label.SetTextColor(color);
			label.SetTextSize(12);
			boolLabel == true ? layout.AddChild(label) : null;
	
			var input = app.CreateTextEdit("", width, null, options+", Singleline");
			input.SetBackColor("#00ffffff");
			input.SetTextColor(this.colors.black);
			input.SetTextSize(16);
			input.SetHint(hint);
			input.SetCursorColor(this.colors.dark);
			input.SetPadding(2.5, 7.5, 2.5, 12.5, "dp");
			layout.AddChild(input);
			if(boolLabel == true) {
				input.SetHint("");
			}
		
			var bottomBorder = app.CreateImage(null, null, null, "fix", 1, 1);
			bottomBorder.SetSize(width*this.sw, 4, "px" );
			bottomBorder.SetColor(color);
			layout.AddChild(bottomBorder);
			
		return {
			Layout: layout,
			TextEdit: input,
		};
	},
	CreateTextEditUnique: function(width, options, hint, textColor, backColor) {
		textColor = textColor || this.colors.blue.blue;
		backColor = backColor || this.colors.white;
		var il = app.CreateLayout("Absolute");
		il.SetSize(width, null);
			var bg = app.CreateButton("", null, null, "Custom");
			bg.SetSize(width*this.swdp, 65, "dp");
			bg.SetStyle(backColor, backColor, 8, backColor, 1, 0.5);
			bg.SetPosition( 0, this.Fr(3) );
			il.AddChild(bg);
			
			var bnm = app.CreateLayout("Linear", "VCenter, Horizontal, Left");
			bnm.SetSize(width*this.swdp-10, 65, "dp");
				var input = app.CreateTextEdit("", null, null, options+", Singleline");
				input.SetSize( width*this.swdp-10, null, "dp");
				input.SetTextColor(textColor);
				input.SetTextSize(16);
				input.SetHint(hint||"");
				input.SetPadding(20, 0, 20, 0, "dp");
				input.SetBackColor(this.colors.transparent);
				input.SetCursorColor(this.colors.dark);
				bnm.AddChild(input);
			il.AddChild(bnm);
			
		return {
			Layout: il,
			TextEdit: input,
		};
	},
	CreateTextEditSearch: function(width, options, hint, color, backColor) {
		color = color || this.colors.blue.blue;
		backColor = backColor || this.colors.white;
		var il = app.CreateLayout("Absolute");
		il.SetSize(width, null);
			var bg = app.CreateButton("", null, null, "Custom");
			bg.SetSize(width*this.swdp, 65, "dp");
			bg.SetStyle(backColor, backColor, 8, this.colors.grey.lighten3, 1, 0.5);
			bg.SetPosition( 0, this.Fr(3) );
			il.AddChild(bg);
			
			var bnm = app.CreateLayout("Linear", "VCenter, Horizontal, Left");
			bnm.SetSize(width*this.swdp, 65, "dp");
				var input = app.CreateTextEdit("", null, null, options+", Singleline");
				input.SetSize( (width*this.swdp)-60, null, "dp");
				input.SetTextColor(this.colors.black);
				input.SetTextSize(16);
				input.SetHint(hint||"");
				input.SetPadding(25, 0, 0, 0, "dp");
				input.SetBackColor(this.colors.transparent);
				input.SetCursorColor(this.colors.dark);
				bnm.AddChild(input);
				input.SetOnFocus(function(state) {
					var data = UI.values.input[this.id];
					if(state) {
						data.icon.SetTextColor(data.color);
					} else if(!state && this.GetText()=="" ) {
						data.icon.SetTextColor(UI.colors.grey.grey);
					}
				});
			
				var ic = app.CreateButton("search", null, null, "Custom");
				ic.SetSize(55, 55, "dp");
				ic.SetMargins(0, 3, 0, 0, "dp");
				ic.SetFontFile(this.fonts.icon);
				ic.SetStyle(backColor, backColor, 50, 0, 0, 0);
				ic.SetTextSize(22);
				ic.SetTextColor(UI.colors.grey.grey);
				bnm.AddChild(ic);
			
			il.AddChild(bnm);
			
			this.values.input[input.id] = {
				color: color,
				icon: ic,
			};
			
		return {
			Layout: il,
			TextEdit: input,
		};
	},
	CreateTEFilledIconLeft: function(width, options, icon, hint, boolLabel, color) {
		color = color || this.colors.blue.blue;
		boolLabel = boolLabel || false;
		var cont = app.CreateLayout("Linear", "Left, Horizontal");
			var icon = app.CreateText(icon);
			icon.SetFontFile(this.fonts.icon);
			icon.SetTextColor(this.colors.grey.grey);
			icon.SetTextSize(24);
			icon.SetMargins(0, 4, 10, 0, "dp");
			cont.AddChild(icon);
			
			var qwerty = app.CreateLayout("Linear", "Left");
			qwerty.SetSize(width*this.swdp-50, null, "dp");
				var label = app.CreateText(hint);
				label.SetTextColor(color);
				label.SetTextSize(12);
				label.Hide();
				if(boolLabel == true) {
					qwerty.AddChild(label);
					icon.SetMargins(0, 25, 10, 0, "dp");
				}
							
				var txtEdt = app.CreateTextEdit("", null, null, options+", Singleline");
				txtEdt.SetBackColor("#00ffffff");
				txtEdt.SetTextColor(this.colors.black);
				txtEdt.SetTextSize(16);
				txtEdt.SetSize(width*this.swdp-50, null, "dp");
				txtEdt.SetHint(hint);
				txtEdt.SetCursorColor(this.colors.dark);
				txtEdt.SetPadding(5, 7.5, 2.5, 7.5, "dp");
				qwerty.AddChild(txtEdt);
				txtEdt.SetOnFocus(function(state) {
					var data = UI.values.input[this.id];
					if(state == true) {
						data.border.SetColor(data.color);
						data.icon.SetTextColor(data.color);
						if(data.boolLabel != false) {
							data.label.Show();
							this.SetHint("");
						}
					} else if(!state && this.GetText()=="" ) {
						data.boolLabel ? data.label.Hide() : null;
						this.SetHint(data.hint);
						data.icon.SetTextColor(UI.colors.grey.grey);
						data.border.SetColor("#bdbdbd");
					}
				});
							
				var bottomBorder = app.CreateImage(null, null, null, "fix", 1, 1);
				bottomBorder.SetSize(width*this.swdp-50, 2, "dp" );
				bottomBorder.SetColor("#bdbdbd");
				qwerty.AddChild(bottomBorder);
			cont.AddChild(qwerty);
			
			this.values.input[txtEdt.id] = {
				label: label,
				color: color,
				hint: hint,
				border: bottomBorder,
				icon: icon,
				boolLabel: boolLabel,
			};
			
		return {
			Layout: cont,
			TextEdit: txtEdt,
			Icon: icon,
		};
	},
	CreateTEFilledIconRight : function(width, options, icon, hint, boolLabel, color) {
		color = color || this.colors.blue.blue;
		boolLabel = boolLabel || false;
		var cont = app.CreateLayout("Linear", "VCenter");
			var qwerty = app.CreateLayout("Linear", "Left, Horizontal, VCenter");
			qwerty.SetSize(width*this.swdp, null, "dp");
				var cxz = app.CreateLayout("Linear", "Left");
				cxz.SetSize(width*this.swdp-52.5, null, "dp");
					var label = app.CreateText(hint);
					label.SetTextColor(color);
					label.SetTextSize(12);
					label.Hide();
					boolLabel == true? cxz.AddChild(label) : cxz.SetMargins(0, 8, 0, 0, "dp");
							
					var txtEdt = app.CreateTextEdit("", null, null, options+", Singleline");
					txtEdt.SetBackColor("#00ffffff");
					txtEdt.SetTextColor(this.colors.black);
					txtEdt.SetTextSize(16);
					txtEdt.SetSize(width*this.swdp-50, null, "dp");
					txtEdt.SetHint(hint);
					txtEdt.SetCursorColor(this.colors.dark);
					txtEdt.SetPadding(2.5, 7.5, 0, 7.5, "dp");
					cxz.AddChild(txtEdt);
					txtEdt.SetOnFocus(function(state) {
    					var data = UI.values.input[this.id];
    					if(state == true) {
    						data.border.SetColor(data.color);
    						data.icon.SetTextColor(data.color);
    						if(data.boolLabel != false) {
    							data.label.Show();
    							this.SetHint("");
    						}
    					} else if(!state && this.GetText()=="" ) {
    						data.boolLabel ? data.label.Hide() : null;
    						this.SetHint(data.hint);
    						data.icon.SetTextColor(UI.colors.grey.grey);
    						data.border.SetColor("#bdbdbd");
    					}
    				});
				qwerty.AddChild(cxz);
							
				var icon = app.CreateButton(icon, null, null, "Custom");
				icon.SetFontFile(this.fonts.icon);
				icon.SetTextColor(this.colors.grey.grey);
				icon.SetTextSize(22);
				icon.SetStyle(this.colors.white, this.colors.white, 50, 0, 0, 0);
				icon.SetSize(55, 55, "dp");
				icon.SetMargins(0, 12, 0, 0, "dp");
				qwerty.AddChild(icon);
			cont.AddChild(qwerty);
			
			var bottomBorder = app.CreateImage(null, null, null, "fix", 1, 1);
			bottomBorder.SetSize(width*this.swdp, 2, "dp" );
			bottomBorder.SetColor("#bdbdbd");
			cont.AddChild(bottomBorder);
			
			this.values.input[txtEdt.id] = {
				label: label,
				color: color,
				hint: hint,
				border: bottomBorder,
				icon: icon,
				boolLabel: boolLabel,
			};
			
		return {
			Layout: cont,
			TextEdit: txtEdt,
			Icon: icon,
		};
	},
	CreateTEOutlineIconLeft: function(width, options, icon, hint, boolLabel, color, backColor) {
		color = color || this.colors.blue.blue;
		backColor = backColor || this.colors.white;
		boolLabel = boolLabel || false;
		options = options ? options.toLowerCase() : "Left, Singleline";
		var radius = 4;
		options.search("round") > -1 ? radius = 50 : radius = 4;
		var il = app.CreateLayout("Absolute");
		il.SetSize(width, null);
			var bg = app.CreateButton("", null, null, "Custom");
			bg.SetSize( width*this.swdp, 65, "dp" );
			bg.SetStyle("#00000000", "#00000000", radius, "#bdbdbd", 2, 0);
			bg.SetPosition(0, this.Fr(6));
			il.AddChild(bg);
			
			var lbl = app.CreateText(hint);
			lbl.SetFontFile(this.fonts.regular);
			lbl.SetTextColor(color);
			lbl.SetTextSize(12);
			lbl.SetPadding(4, 0, 4, 0, "dp");
			lbl.SetBackColor(backColor);
			lbl.SetPosition(0.048, 0);
			lbl.Hide();
			if(boolLabel != false) {
				options.search("round") > -1 ? lbl.SetPosition(0.075, 0) : null;
				il.AddChild(lbl);
			}
			
			var bnm = app.CreateLayout("Linear", "VCenter, Horizontal, Left");
			bnm.SetSize(width*this.swdp, 65, "dp");
			bnm.SetPosition( 0, this.Fr(3));
				var icon = app.CreateText(icon);
				icon.SetFontFile(this.fonts.icon);
				icon.SetTextColor(this.colors.grey.grey);
				icon.SetTextSize(22);
				icon.SetMargins(20, 0, 12, 0, "dp");
				bnm.AddChild(icon);
				
				var input = app.CreateTextEdit("", null, null, options+", Singleline");
				input.SetSize( (width*this.swdp)-60, null, "dp");
				input.SetTextColor(this.colors.black);
				input.SetTextSize(16);
				input.SetPadding(0, 0, 0, 0, "dp");
				input.SetBackColor(this.colors.transparent);
				input.SetCursorColor(this.colors.dark);
				input.SetHint(hint);
				bnm.AddChild(input);
				input.SetOnFocus(function(state) {
					var data = UI.values.input[this.id];
					if(state == true) {
						data.border.SetStyle("#00000000", "#00000000", data.radius, data.color, 2, 0);
						data.icon.SetTextColor(data.color);
						if(data.boolLabel != false) {
							data.label.Show();
							this.SetHint("");
						}
					} else if(!state && this.GetText()=="" ) {
						data.boolLabel ? data.label.Hide() : null;
						this.SetHint(data.hint);
						data.icon.SetTextColor(UI.colors.grey.grey);
						data.border.SetStyle("#00000000", "#00000000", data.radius, "#bdbdbd", 2, 0);
					}
				});

			il.AddChild(bnm);
			
			this.values.input[input.id] = {
				label: lbl,
				color: color,
				hint: hint,
				border: bg,
				boolLabel: boolLabel,
				radius: radius,
				icon: icon,
			};
		return {
			Layout: il,
			TextEdit: input,
			Icon: icon,
		};
	},
	CreateTEOutlineIconRight: function(width, options, icon, hint, boolLabel, color, backColor) {
		color = color || this.colors.blue.blue;
		backColor = backColor || this.colors.white;
		boolLabel = boolLabel || false;
		options ? options = options.toLowerCase() : options = "Left, Singleline";
		var radius = 4;
		options.search("round") > -1 ? radius = 50 : radius = 4;
		var il = app.CreateLayout("Absolute");
		il.SetSize(width, null);
			var bg = app.CreateButton("", null, null, "Custom");
			bg.SetSize( width*this.swdp, 65, "dp" );
			bg.SetStyle("#00000000", "#00000000", radius, "#bdbdbd", 2, 0);
			bg.SetPosition(0, this.Fr(6));
			il.AddChild(bg);
			
			var lbl = app.CreateText(hint);
			lbl.SetFontFile(this.fonts.regular);
			lbl.SetTextColor(color);
			lbl.SetTextSize(12);
			lbl.SetPadding(4, 0, 4, 0, "dp");
			lbl.SetBackColor(backColor);
			lbl.SetPosition(0.048, 0);
			lbl.Hide();
			if(boolLabel != false) {
				options.search("round") > -1 ? lbl.SetPosition(0.075, 0) : null;
				il.AddChild(lbl);
			}
			
			var bnm = app.CreateLayout("Linear", "VCenter, Horizontal, Left");
			bnm.SetSize(width*this.swdp, 65, "dp");
			bnm.SetPosition( 0, 0.008);
				var input = app.CreateTextEdit("", null, null, options+", Singleline");
				input.SetSize( (width*this.swdp)-60, null, "dp");
				input.SetTextColor(this.colors.black);
				input.SetTextSize(16);
				options.search("round") > -1 ? input.SetPadding(30, -4, 18, 0, "dp") : input.SetPadding(20, -4, 18, 0, "dp");
				input.SetBackColor(this.colors.transparent);
				input.SetCursorColor(this.colors.dark);
				input.SetHint(hint);
				bnm.AddChild(input);
				input.SetOnFocus(function(state) {
					var data = UI.values.input[this.id];
					if(state == true) {
						data.border.SetStyle("#00000000", "#00000000", data.radius, data.color, 2, 0);
						data.icon.SetTextColor(data.color);
						if(data.boolLabel != false) {
							data.label.Show();
							this.SetHint("");
						}
					} else if(!state && this.GetText()=="" ) {
						data.boolLabel ? data.label.Hide() : null;
						this.SetHint(data.hint);
						data.icon.SetTextColor(UI.colors.grey.grey);
						data.border.SetStyle("#00000000", "#00000000", data.radius, "#bdbdbd", 2, 0);
					}
				});
				
				var icon = app.CreateButton(icon, null, null, "Custom");
				icon.SetFontFile(this.fonts.icon);
				icon.SetTextColor(this.colors.grey.grey);
				icon.SetTextSize(22);
				icon.SetStyle(this.colors.white, this.colors.white, 50, 0, 0, 0);
				icon.SetSize(55, 55, "dp");
				icon.SetMargins(0, 2, 0, 0, "dp");
				bnm.AddChild(icon);
			il.AddChild(bnm);
			
			this.values.input[input.id] = {
				label: lbl,
				color: color,
				hint: hint,
				border: bg,
				boolLabel: boolLabel,
				radius: radius,
				icon: icon,
			};
		return {
			Layout: il,
			TextEdit: input,
			Icon: icon,
		};
	},
	CreateTESearchUnique: function(width, hint, icon, iconColor) {
		width = width*this.swdp || this.swdp;
		iconColor = iconColor || this.colors.black;
		var asdCont = app.CreateLayout("Absolute");
		asdCont.SetSize(width, null, "dp");
			var bgs = app.CreateButton("", null, null, "Custom");
			bgs.SetSize(width, 60, "dp");
			bgs.SetStyle(this.colors.grey.lighten3, this.colors.grey.lighten3, 60, 0, 0, 0);
			asdCont.AddChild(bgs);
			
			var asdBox = app.CreateLayout("Linear", "Horizontal, Left, VCenter");
			asdBox.SetSize(width, 60, "dp");
			asdBox.SetPadding(6, 0, 6, 0, "dp");
				var asdIcon = app.CreateText(icon || "search");
				asdIcon.SetTextSize(22);
				asdIcon.SetFontFile(this.fonts.icon);
				asdIcon.SetTextColor(this.colors.grey.grey);
				asdIcon.SetMargins(15, -3, 15, 0, "dp");
				asdBox.AddChild(asdIcon);
				
				var input = app.CreateTextEdit("", null, null, "Left, SingleLine");
				input.SetSize( width-42, null, "dp");
				input.SetTextColor(this.colors.black);
				input.SetTextSize(16);
				input.SetMargins(0, -3, 0, 0, "dp");
				input.SetPadding(0, 3, 20, 3, "dp");
				input.SetBackColor(this.colors.transparent);
				input.SetCursorColor(this.colors.dark);
				input.SetHint(hint || "Search");
				input.SetOnFocus(function(state) {
					var data = UI.values.input[this.id];
					if(state) {
						data.icon.SetTextColor(data.color);
					} else if(!state && this.GetText()=="" ) {
						data.icon.SetTextColor(UI.colors.grey.grey);
					}
				});
				asdBox.AddChild(input);
			asdCont.AddChild(asdBox);
			
			this.values.input[input.id] = {
				color: iconColor,
				icon: asdIcon,
			};
		return {
			Layout: asdCont,
			TextEdit: input,
		};
	},
	CreateTESearchElegant: function(width, hint, icon, iconPosition, color, option) {
		width = width*this.swdp || this.swdp;
		color = color || this.colors.blue.darken1;
		iconPosition ? iconPosition = iconPosition.toLowerCase() : iconPosition = "right";
		option ? option = option.toLowerCase() : option = "normal";
		var size;
		option.search("small") > -1 ? size = 50 : size = 60;
		
		var asdCont = app.CreateLayout("Absolute");
		asdCont.SetSize(width, null, "dp");
			var bgs = app.CreateButton("", null, null, "Custom");
			bgs.SetSize(width, size, "dp");
			asdCont.AddChild(bgs);
			option.search("border") == 0 ? bgs.SetStyle(this.colors.white, this.colors.white, 60, this.colors.grey.lighten2, 1, 0) : bgs.SetStyle(this.colors.grey.lighten3, this.colors.grey.lighten3, 60, 0, 0, 0);
	
			var asdBox = app.CreateLayout("Linear", "Horizontal, Left, VCenter");
			asdBox.SetSize(width, size, "dp");
			asdBox.SetPadding(4, 0, 4, 0, "dp");
				var asdIcon = app.CreateButton(icon || "search", null, null, "Custom");
				asdIcon.SetSize(size-5, size-5, "dp");
				asdIcon.SetStyle(color, color, 50, 0, 0, 0);
				asdIcon.SetTextSize( option.search("small") > -1 ? 16 : 22 );
				asdIcon.SetFontFile(this.fonts.icon);
				asdIcon.SetTextColor(this.colors.white);
				
				input = app.CreateTextEdit("", null, null, "Left, SingleLine");
				input.SetSize( width-(size+2), null, "dp");
				input.SetTextColor(this.colors.black);
				input.SetTextSize(16);
				input.SetMargins(0, -3, 0, 0, "dp");
				input.SetBackColor(this.colors.transparent);
				input.SetCursorColor(this.colors.dark);
				input.SetHint(hint || "Search");				
				if(iconPosition == "right") {
					input.SetPadding(20, 3, 20, 3, "dp");
					asdBox.AddChild(input);
					asdBox.AddChild(asdIcon);
				} else {
					input.SetPadding(8, 3, 20, 3, "dp");
					asdBox.AddChild(asdIcon);
					asdBox.AddChild(input);
				}
			asdCont.AddChild(asdBox);
		return {
			Layout: asdCont,
			TextEdit: input,
		};
	},
	CreateTextAreaFilled: function(width, height, hint, boolLabel, color) {
		color = color || this.colors.blue.blue;
		boolLabel = boolLabel || false;
		var layout = app.CreateLayout("Linear", "Vertical, Left");
		layout.SetBackColor("#00000000");
    		var label = app.CreateText(hint);
    		label.SetTextColor(color);
    		label.SetTextSize(12);
    		label.Hide();
    		if( boolLabel ) layout.AddChild(label);
    	
    		var input = app.CreateTextEdit("", width, height, "Left, Multiline");
    		input.SetBackColor("#00ffffff");
    		input.SetTextColor(this.colors.black);
    		input.SetTextSize(16);
    		input.SetHint(hint || "Enter text");
    		input.SetCursorColor(this.colors.dark);
    		input.SetPadding(2.5, 7.5, 2.5, 10, "dp");
    		layout.AddChild(input);
    		input.SetOnFocus(function(state) {
    			var data = UI.values.input[this.id];
    			if(state) {
    				data.border.SetColor(data.color);	
    				if(data.boolLabel != false) {
    					data.label.Show();
    					this.SetHint("");
    				}
    			} else if(!state && this.GetText()=="" ){
    					data.label ? data.label.Hide() : null;
    					this.SetHint(data.hint);
    					data.border.SetColor("#bdbdbd");
    			}
    		});
				
			var bottomBorder = app.CreateImage(null, null, null, "fix", 1, 1);
			bottomBorder.SetSize(width*this.sw, 4, "px" );
			bottomBorder.SetColor("#bdbdbd");
			layout.AddChild(bottomBorder);
			this.values.input[input.id] = {
				label: label,
				color: color,
				hint: hint,
				border: bottomBorder,
				boolLabel: boolLabel,
			};
		return {
			Layout: layout,
			TextEdit: input,
		};
	},
	CreateTextAreaFilledA: function(width, height, hint, boolLabel, color) {
		color = color || this.colors.blue.blue;
		boolLabel = boolLabel || false;
		var layout = app.CreateLayout("Linear", "Vertical, Left");
		layout.SetBackColor("#00000000");
			var label = app.CreateText(hint);
			label.SetTextColor(color);
			label.SetTextSize(12);
			
			var input = app.CreateTextEdit("", width, height, "Left, Multiline");
			input.SetBackColor("#00ffffff");
			input.SetTextColor(this.colors.black);
			input.SetTextSize(16);
			input.SetCursorColor(this.colors.dark);
			input.SetPadding(2.5, 7.5, 2.5, 10, "dp");
			
			boolLabel == true ? layout.AddChild(label) : input.SetHint(hint || "Enter text");
			layout.AddChild(input); 
	
			var bottomBorder = app.CreateImage(null, null, null, "fix", 1, 1);
			bottomBorder.SetSize(width*this.sw, 4, "px" );
			bottomBorder.SetColor(color);
			layout.AddChild(bottomBorder);
		return {
			Layout: layout,
			TextEdit: input,
		};
	},
	CreateTextAreaOutline: function(width, height, hint, boolLabel, color, backColor) {
		color = color || this.colors.blue.blue;
		backColor = backColor || this.colors.white;
		boolLabel = boolLabel || false;
		var il = app.CreateLayout("Absolute");
		il.SetSize(width, height);
			var bg = app.CreateButton("", null, null, "Custom");
			bg.SetSize( width, height-0.001);
			bg.SetStyle("#00000000", "#00000000", 4, "#bdbdbd", 2, 0);
			bg.SetPosition(0, this.DpToPx(8)/this.sh);
			il.AddChild(bg);
			
			var lbl = app.CreateText(hint);
			lbl.SetFontFile(this.fonts.regular);
			lbl.SetTextColor(color);
			lbl.SetTextSize(12);
			lbl.SetPadding(4, 0, 4, 0, "dp");
			lbl.SetBackColor(backColor);
			lbl.SetPosition(0.048, 0);
			lbl.Hide();
			if(boolLabel != false) {
				il.AddChild(lbl);
			}
	
			var bnm = app.CreateLayout("Linear", "VCenter, Horizontal, Left");
			bnm.SetSize(width, height);
			bnm.SetPosition( 0, 0.008);
				var input = app.CreateTextEdit("", width, height, "Left, Multiline");
				input.SetTextColor(this.colors.black);
				input.SetTextSize(16);
				input.SetPadding(20, 15, 18, 12, "dp");
				input.SetBackColor(this.colors.transparent);
				input.SetCursorColor(this.colors.dark);
				input.SetHint(hint);
				bnm.AddChild(input);
				input.SetOnFocus(function(state) {
					var data = UI.values.input[this.id];
					if(state == true) {
						data.border.SetStyle("#00000000", "#00000000", 4, data.color, 2, 0);
						if(data.boolLabel != false) {
							data.label.Show();
							this.SetHint("");
						}
					} else if( !state && this.GetText()=="" ) {
						data.label ? data.label.Hide() : null;
						this.SetHint(data.hint);
						data.border.SetStyle("#00000000", "#00000000", 4, "#bdbdbd", 2, 0);
					}
				});
			il.AddChild(bnm);
			
			this.values.input[input.id] = {
				label: lbl,
				color: color,
				hint: hint,
				border: bg,
				boolLabel: boolLabel,
			};
		return {
			Layout: il,
			TextEdit: input,
		};
	},
	CreateTextAreaOutlineA: function(width, height, hint, boolLabel, color, backColor) {
		color = color || this.colors.blue.blue;
		backColor = backColor || this.colors.white;
		boolLabel = boolLabel || false;
		var il = app.CreateLayout("Absolute");
		il.SetSize(width, height);
			var bg = app.CreateButton("", null, null, "Custom");
			bg.SetSize( width, height-0.001);
			bg.SetStyle("#00000000", "#00000000", 4, color, 2, 0);
			bg.SetPosition(0, this.Fr(6));
			il.AddChild(bg);
			
			var lbl = app.CreateText(hint);
			lbl.SetFontFile(this.fonts.regular);
			lbl.SetTextColor(color);
			lbl.SetTextSize(12);
			lbl.SetPadding(4, 0, 4, 0, "dp");
			lbl.SetBackColor(backColor);
			lbl.SetPosition(0.048, 0);
			if(boolLabel != false) {
				il.AddChild(lbl);
			}
	
			var bnm = app.CreateLayout("Linear", "VCenter, Horizontal, Left");
			bnm.SetPosition( 0, this.Fr(8));
				var input = app.CreateTextEdit("", width, height, "Left, Multiline");
				input.SetTextColor(this.colors.black);
				input.SetTextSize(16);
				input.SetPadding(20, 12, 18, 12, "dp");
				input.SetBackColor(this.colors.transparent);
				input.SetCursorColor(this.colors.dark);
				bnm.AddChild(input);
				boolLabel != false ? input.SetHint("") : input.SetHint(hint);
			il.AddChild(bnm);
			
			this.values.input[input.id] = {
				label: lbl,
				color: color,
				hint: hint,
				border: bg,
				boolLabel: boolLabel,
			};
		return {
			Layout: il,
			TextEdit: input,
		};
	},
	
	// ===================== NAVBARS =====================
	CreateAppBar: function(title, logoIcon, controls, color, fontWeight) {
	    return new CreateAppBar(title, logoIcon, controls, color, fontWeight);
	    function CreateAppBar(title, logoIcon, controls, color, fontWeight) {
			color = color || "#ffffff";
			fontWeight = fontWeight || "Regular";
			fontWeight = fontWeight.toFontName();
			controls = controls.split(",");

			this.id = UI.CreateID();
			UI.values.navbars[this.id] = {navbar: null, menu: null, title: null, menuCallback: null, controlCallback: null};

			this.SetOnMenuTouch = function(cb) {
				UI.values.navbars[this.id].menuCallback = cb;
			}
			this.SetOnControlTouch = function(cb) {
				UI.values.navbars[this.id].controlCallback = cb;
			}
			this.SetTitleText = function(text) {
				UI.values.navbars[this.id].title.SetText(text);
			}
			this.SetTitleTextColor = function(color) {
				UI.values.navbars[this.id].title.SetTextColor(color);
			}
			this.SetMenuIcon = function(icon) {
				UI.values.navbars[this.id].menu.SetText(icon);
			}
			this.SetMenuIconColor = function(color) {
				UI.values.navbars[this.id].menu.SetTextColor(color);
			}

			this.AppBar = app.CreateLayout("Absolute");
				var shadow = UI.CreateButtonRaised("", null, null, "#ffffffff");
				shadow.SetSize( UI.swdp+24, 55, "dp");
				shadow.SetPosition( UI.Fr(-12), UI.Fr(7) );
				this.AppBar.AddChild(shadow);
			
				var header = app.CreateLayout( "Linear", "VCenter, Left, Horizontal");
				header.SetSize( UI.swdp, 55, "dp");
				header.SetBackColor(color);
				header.SetPosition(0, 0);
					var menu = app.CreateButton( logoIcon||"menu", null, null, "Custom");
					menu.SetFontFile( UI.fonts.icon);
					menu.SetTextSize(25, "dp");
					menu.SetMargins( 0, 3, 10, 0, "dp");
					menu.SetSize(55, 55, "dp");
					menu.SetTextColor("#ffffff");
					menu.SetStyle( color, color, 50, 0, 0, 0 );
					header.AddChild(menu);
					UI.values.objectIDs[menu.id] = this.id;
					UI.values.navbars[this.id].menu = menu;
					menu.SetOnTouch(function() {
						var id = UI.values.objectIDs[this.id];
						var cb = UI.values.navbars[id].menuCallback;
						if(cb) cb(this); 
					});
				
					var appTitle = app.CreateText(title, null, null, "Left");
					appTitle.SetSize(UI.swdp-70-(55*controls.length)+(10*controls.length), null, "dp");
					appTitle.SetFontFile(fontWeight);
					appTitle.SetEllipsize("end");
					appTitle.SetTextSize(20);
					appTitle.SetTextColor("#ffffff");
					header.AddChild(appTitle);
					UI.values.navbars[this.id].title = appTitle;
				
					for(var i=0; i<controls.length; i++) {
						ctrl = app.CreateButton( controls[i].trim(), null, null, "Custom");
						ctrl.SetFontFile( UI.fonts.icon);
						ctrl.SetTextSize(24, "dp");
						ctrl.SetMargins( 0, 2.5, -10, 0, "dp");
						ctrl.SetSize(55, 55, "dp");
						ctrl.SetTextColor("#ffffff");
						ctrl.SetStyle( color, color, 50, 0, 0, 0);
						header.AddChild(ctrl);
						UI.values.objectIDs[ctrl.id] = this.id;

						ctrl.SetOnTouch(function() {
							var id = UI.values.objectIDs[this.id];
							var cb = UI.values.navbars[id].controlCallback;
							if(cb) cb(this.GetText()); 
						});
					}	
				this.AppBar.AddChild(header);
				UI.values.navbars[this.id].navbar = this.AppBar;
		}
	},
	CreateAppBarElegant: function(title, logoIcon, controls, color) {
		return new AppBarElegant(title, logoIcon, controls, color);
		function AppBarElegant(title, logoIcon, controls, color) {
			color = color || "#000000";
			var backColor =  "#ffffff";
        	var fontWeight = "Bold".toFontName();
        	controls = controls.split(",");
        
        	this.id = UI.CreateID();
        	UI.values.navbars[this.id] = {navbar: null, menu: null, title: null, menuCallback: null, controlCallback: null};
        
        	this.SetOnMenuTouch = function(cb) {
        		UI.values.navbars[this.id].menuCallback = cb;
        	}
        	this.SetOnControlTouch = function(cb) {
        		UI.values.navbars[this.id].controlCallback = cb;
        	}
        	this.SetTitleText = function(text) {
        		UI.values.navbars[this.id].title.SetText(text);
        	}
        	this.SetTitleTextColor = function(color) {
        		UI.values.navbars[this.id].title.SetTextColor(color);
        	}
        	this.SetMenuIcon = function(icon) {
        		UI.values.navbars[this.id].menu.SetText(icon);
        	}
        	this.SetMenuIconColor = function(color) {
        		UI.values.navbars[this.id].menu.SetTextColor(color);
        	}
        
        	this.AppBar = app.CreateLayout("Absolute");
        		var shadow = UI.CreateButtonRaised("", null, null, "#00ffffff");
        		shadow.SetStyle("#00ffffff", "#00ffffff", 0, 0, 0, 1);
        		shadow.SetSize( UI.swdp+50, 55, "dp");
        		shadow.SetEnabled(false);
        		shadow.SetPosition( UI.Fr(-25), UI.Fr(7) );
        		this.AppBar.AddChild(shadow);
        	
        		var header = app.CreateLayout( "Linear", "VCenter, Left, Horizontal");
        		header.SetSize( UI.swdp, 55, "dp");
        		header.SetBackColor(backColor);
        		header.SetPosition(0, 0);
        			var menu = app.CreateButton( logoIcon||"menu", null, null, "Custom");
        			menu.SetFontFile( UI.fonts.icon);
        			menu.SetTextSize(25, "dp");
        			menu.SetMargins( 0, 3, 10, 0, "dp");
        			menu.SetSize(55, 55, "dp");
        			menu.SetTextColor(color);
        			menu.SetStyle( backColor, backColor, 50, 0, 0, 0 );
        			header.AddChild(menu);
        			UI.values.objectIDs[menu.id] = this.id;
        			UI.values.navbars[this.id].menu = menu;
        			menu.SetOnTouch(function() {
        				var id = UI.values.objectIDs[this.id];
        				var cb = UI.values.navbars[id].menuCallback;
        				if(cb) cb(this); 
        			});
        		
        			var appTitle = app.CreateText(title, null, null, "Left");
        			appTitle.SetSize(UI.swdp-70-(55*controls.length)+(10*controls.length), null, "dp");
        			appTitle.SetFontFile(fontWeight);
        			appTitle.SetEllipsize("end");
        			appTitle.SetTextSize(20);
        			appTitle.SetTextColor(color);
        			header.AddChild(appTitle);
        			UI.values.navbars[this.id].title = appTitle;
        		
        			for(var i=0; i<controls.length; i++) {
        				ctrl = app.CreateButton( controls[i].trim(), null, null, "Custom");
        				ctrl.SetFontFile( UI.fonts.icon);
        				ctrl.SetTextSize(24, "dp");
        				ctrl.SetMargins( 0, 2.5, -5, 0, "dp");
        				ctrl.SetSize(50, 50, "dp");
        				ctrl.SetTextColor(color);
        				ctrl.SetStyle( "#eeeeee", "#eeeeee", 50, 0, 0, 0);
        				header.AddChild(ctrl);
        				UI.values.objectIDs[ctrl.id] = this.id;
        				ctrl.SetOnTouch(function() {
        					var id = UI.values.objectIDs[this.id];
        					var cb = UI.values.navbars[id].controlCallback;
        					if(cb) cb(this.GetText()); 
        				});
        			}	
        		this.AppBar.AddChild(header);
        		UI.values.navbars[this.id].navbar = this.AppBar;	
		}
	},
	CreateAppBarModern: function(hint, icon, color, options) {
	    return new AppBarModern(hint, icon, color, options);
	    function AppBarModern(hint, icon, color, options) {
	        this.id = UI.CreateID();
        	UI.values.navbars[this.id] = {navbar: null, menu: null, title: null, menuCallback: null, controlCallback: null};
	        
	        this.SetOnMenuTouch = function(cb) {
	            UI.values.navbars[this.id].menuCallback = cb;
	        }
	        
	        this.SetOnControlTouch = function(cb) {
	            UI.values.navbars[this.id].controlCallback = cb;
	        }
	        
	        var radius = 10;
	        var shadow = 0.3;
	        var color = color || "#000000";
	        if(options && options.toLowerCase() == "round") {
	            radius = 50;
	            shadow = 0;
	        }
    		
    		this.AppBar	= app.CreateLayout("Absolute");
    		this.AppBar.SetSize(1, null);
    			var background = app.CreateButton("", null, null, "Custom");
    			background.SetStyle("#ffffff", "#ffffff", radius, UI.colors.grey.lighten2, 1, shadow);
    			background.SetSize(UI.swdp-10, 65, "dp");
    			background.SetPosition(UI.DpToPx(5)/UI.sw, UI.DpToPx(2.5)/UI.sh);
    			this.AppBar.AddChild(background);
    			
    			var header = app.CreateLayout( "Linear", "VCenter, Left, Horizontal");
    			header.SetSize(UI.swdp-20, 65, "dp");
    			header.SetPosition( UI.DpToPx(10)/UI.sw, UI.DpToPx(0)/UI.sh );
    				var menu = app.CreateButton( "menu", null, null, "Custom");
    				menu.SetMargins( 0, 2.5, 0, 0, "dp");
    				menu.SetSize(60, 60, "dp");
    				menu.SetTextSize(25, "dp");
    				menu.SetTextColor(color);
    				menu.SetStyle("#ffffff", "#ffffff", 50, 0, 0, 0);
    				menu.SetFontFile(UI.fonts.icon);
    				header.AddChild(menu);
    				UI.values.objectIDs[menu.id] = this.id;
        			menu.SetOnTouch(function() {
        				var id = UI.values.objectIDs[this.id];
        				var cb = UI.values.navbars[id].menuCallback;
        				if(cb) cb(this);
        			});
    		
    				this.Search = app.CreateTextEdit("", null, null, "SingleLine, Left");
    				this.Search.SetSize(UI.swdp-137.5, null, "dp");
    				this.Search.SetHint(hint || "Search");
    				this.Search.SetBackColor("#ffffff");
    				this.Search.SetCursorColor("#000000");
    				this.Search.SetPadding(0);
    				this.Search.SetTextColor("#000000");
    				this.Search.SetTextSize(18);
    				header.AddChild(this.Search);
    				//srci.SetBackColor(this.colors.red.red):
    				
    				var ctrl = app.CreateButton( icon, null, null, "Custom");
    				ctrl.SetFontFile(UI.fonts.icon);
    				ctrl.SetTextSize(24, "dp");
    				ctrl.SetMargins(0, 2.5, 0, 0, "dp");
    				ctrl.SetSize(60, 60, "dp");
    				ctrl.SetTextColor(color);
    				ctrl.SetStyle( "#f5ffffff", "#f5ffffff", 50, 0, 0, 0);
    				header.AddChild(ctrl);
    				UI.values.objectIDs[ctrl.id] = this.id;
    				ctrl.SetOnTouch(function() {
    					var id = UI.values.objectIDs[this.id];
    					var cb = UI.values.navbars[id].controlCallback;
    					if(cb) cb();
    				});
        				
    			this.AppBar.AddChild(header);
	    }
	},
	
	// ===================== DIALOGS =====================
    CreateDialog: function(title, body, okText, color, type, divider, static) {
        return new Dialog(title, body, okText, color, type, divider, static);
        function Dialog(title, body, okText, color, type, divider, static) {
            this.id = UI.CreateID();
            UI.values.dialogs[this.id] = {layout: null, cb: null};
            
            this.SetOnTouchOK = function(cb) {
                UI.values.dialogs[this.id].cb = cb;  
            }
            
            type = type || "rect";
            type = type.toLowerCase();
            type = type == "round" ? true: false;
            static = static || true;
            var layout = app.CreateLayout("Linear", "VCenter, FillXY");
            UI.values.objectIDs[layout.id] = this.id;
            UI.values.dialogs[this.id].layout = layout;
            layout.Hide();
            layout.SetBackColor("#99000000");
                var box = app.CreateLayout("Absolute");
                    var back = app.CreateButton("", null, null, "Custom");
                    back.SetStyle("#ffffff", "#ffffff", 10, 0, 0, 1);
                    back.Hide();
                    box.AddChild( back );
                  
                    var container = app.CreateLayout("Linear", "Left");
                    container.SetSize(UI.swdp-50, null, "dp");
                    container.SetPadding(25, 15, 20, 0, "dp");
                    container.SetBackColor("#ffffff");
                        var txt = UI.CreateTextH6(title, null, null, "", null, "Medium");
                        container.AddChild(txt);
                        
                        var div = UI.CreateDivider();
                        div.SetMargins(0, 12.5, 0, 0, "dp");
                        divider ? container.AddChild(div) : null;
                        
                        var txt = UI.CreateTextParagraph(body, null, null, "Left");
                        txt.SetMargins(0, 10, 0, 10, "dp");
                        txt.SetTextColor(UI.colors.grey.darken1);
                        container.AddChild(txt);
                        
                        var ctrlLay = app.CreateLayout("Linear", "Horizontal, Right");
                        ctrlLay.SetSize(UI.swdp-95, null, "dp");
                            var cancelBtn = UI.CreateButtonFlat("CANCEL", null, null, color);
                            ctrlLay.AddChild(cancelBtn);
                            UI.values.objectIDs[cancelBtn.id] = this.id;
                            cancelBtn.SetOnTouch(function() {
                                var id = UI.values.objectIDs[this.id];
                            	app.DestroyLayout(UI.values.dialogs[id].layout);
                            	if(UI.values.dialogs[id].cb) UI.values.dialogs[id].cb(false);
                            });
                            var okBtn = UI.CreateButtonFlat( okText || "OKAY", null, null, color);
                        	ctrlLay.AddChild(okBtn);
                        	UI.values.objectIDs[okBtn.id] = this.id;
                        	okBtn.SetOnTouch(function() {
                        	    var id = UI.values.objectIDs[this.id];
                            	app.DestroyLayout(UI.values.dialogs[id].layout);
                            	if(UI.values.dialogs[id].cb) UI.values.dialogs[id].cb(true);
                        	});
                        container.AddChild(ctrlLay);
                    box.AddChild(container);
                layout.AddChild( box );
            
            app.AddLayout(layout);
            
            if(static) {
            	layout.SetOnTouchUp(function() {
            		var id = UI.values.objectIDs[this.id];
            		if(UI.values.dialogs[id].cb) UI.values.dialogs[id].cb(false);
            		app.DestroyLayout(this);
            	});
            }
            layout.Animate("FadeIn");
            if(type) {
            	container.SetBackColor("#00000000");
            	container.SetPadding(25, 15, 20, 10, "dp");
            	back.SetSize(box.GetWidth(), box.GetHeight());
            	back.Show();
            }
        }
    },
    CreateBanner: function(text, okText, color) {
        return new Banner(text, okText, color);
        function Banner(text, okText, color) {
            
            this.id = UI.CreateID();
            UI.values.dialogs[this.id] = {layout: null, cb: null};
            
            this.SetOnTouchOK = function(cb) {
                UI.values.dialogs[this.id].cb = cb;
            }
            
            var layout = app.CreateLayout("Absolute", "FillX");
            UI.values.dialogs[this.id].layout = layout;
            layout.Hide();	
            	var bg = app.CreateButton("", null, null, "Custom");
            	bg.SetSize(1.2, null);
            	bg.SetPosition(-0.05, 0);
            	bg.SetStyle("#00ffffff", "#00ffffff", 0, 0, 0, 1);
            	layout.AddChild(bg);
            	
            	var box = app.CreateLayout("Linear", "FillX, Bottom, Left");
           	 	box.SetBackColor("#ffffff");
            	box.SetPadding(25, 15, 25, 0, "dp");
            		txt = UI.CreateTextParagraph(text, null, null, "Left", UI.colors.grey.darken3);
            		box.AddChild(txt);
            	
            		var ctrlLay = app.CreateLayout("Linear", "Horizontal, Right");
            		ctrlLay.SetSize(UI.swdp-50, null, "dp");
            			var cancelBtn = UI.CreateButtonFlat("CANCEL", null, null, color);
            			ctrlLay.AddChild(cancelBtn);
            			UI.values.objectIDs[cancelBtn.id] = this.id;
          	  			cancelBtn.SetOnTouch(function() {
          	  			    var id = UI.values.objectIDs[this.id];
          	  			    UI.values.dialogs[id].layout.Animate("SlideToTop");
          	  			    app.DestroyLayout(UI.values.dialogs[id].layout);
          	  			    UI.values.layoutToRemove = null;
          	  			    clearTimeout(UI.values.timeOut);
          	  			    if(UI.values.dialogs[id].cb) UI.values.dialogs[id].cb(false);
            			});
            			
            			var okBtn = UI.CreateButtonFlat( okText || "OKAY", null, null, color);
            			ctrlLay.AddChild(okBtn);
            			UI.values.objectIDs[okBtn.id] = this.id;
            			okBtn.SetOnTouch(function() {
            			    var id = UI.values.objectIDs[this.id];
          	  			    UI.values.dialogs[id].layout.Animate("SlideToTop");
          	  			    app.DestroyLayout(UI.values.dialogs[id].layout);
          	  			    UI.values.layoutToRemove = null;
          	  			    clearTimeout(UI.values.timeOut);
          	  			    if(UI.values.dialogs[id].cb) UI.values.dialogs[id].cb(true);   
            			});
            			
            		box.AddChild(ctrlLay);
            	layout.AddChild(box);
            app.AddLayout(layout);
            layout.Animate("SlideFromTop");
            bg.SetSize(UI.swdp+40, box.GetHeight()*UI.shdp+5, "dp");
            
            UI.values.layoutToRemove = layout;
			UI.values.timeOut = setTimeout("UI.RemoveLayout()", 5000);
        }
    },
    CreateModal: function(title, bodyText, okText, type, color, bool) {
        return new Modal(title, bodyText, okText, type, color, bool);
        function Modal(title, bodyText, okText, type, color, bool) {
            this.id = UI.CreateID();
            UI.values.dialogs[this.id] = {layout: null, modalBody: null, onOK: null, onClose: null};
            this.SetOnTouchOK = function(cb) {
                UI.values.dialogs[this.id].onOK = cb;
            }
            this.GetLayout = function() {
                return UI.values.dialogs[this.id].modalBody;
            }
            this.Destroy = function() {
                UI.values.dialogs[this.id].layout.Animate("FadeOut");
                app.DestroyLayout( UI.values.dialogs[this.id].layout );
            }
            
            var height = 0.45, width = UI.Fw(UI.swdp-40), posLeft = UI.Fw(20);
            var color = color || UI.colors.blue.blue;
            if(type && type.toLowerCase() == "medium") height = 0.7;
            if(type && type.toLowerCase() == "small") height = 0.3;
            else if(type && type.toLowerCase() == "full") {
                height = 1;
                width = 1;
                posLeft = 0;
            }
            var box = app.CreateLayout("Absolute", "FillXY");
            UI.values.dialogs[this.id].layout = box;
            UI.values.objectIDs[box.id] = this.id;
            box.SetBackColor("#88000000");
            box.Hide();
                var shadow = app.CreateButton("", width, height, "Custom");
                shadow.SetStyle("#ffffff", "#ffffff", 10, 0, 0, 1);
                shadow.SetPosition(posLeft, ((1-height) / 2)+UI.Fr(2.5) );
                box.AddChild(shadow);
                
                var lay = app.CreateLayout("Linear", "left");
                lay.SetSize(width-UI.Fw(10), height-UI.Fr(10));
                lay.SetPosition(posLeft+UI.Fw(5), ((1-height) / 2)+UI.Fr(5));
                    var layTop = app.CreateLayout("Linear", "Left, VCenter");
                    layTop.SetSize(width-UI.Fw(10), UI.Fr(50));
                    layTop.SetPadding(20, 0, 20, 0, "dp");
                        var title = UI.CreateTextH5(title, null, null, "Left", "#000000", "Medium");
                        layTop.AddChild(title);
                    lay.AddChild(layTop);
                    
                    lay.AddChild(UI.CreateDivider());
                    
                    var scroller = app.CreateScroller(width-UI.Fw(10), height-UI.Fr(115));
                        var body = app.CreateLayout("Linear");
                        body.SetSize(width-UI.Fw(10), null);
                        UI.values.dialogs[this.id]
                        body.SetPadding(20, 12, 20, 20, "dp");
                            if(bodyText != "" && bodyText != null) {
                                var bodyText = UI.CreateTextParagraph(bodyText, null, null, "Multiline, Left", UI.colors.grey.darken2);
                                body.AddChild(bodyText);
                            }
                        scroller.AddChild(body);
                        UI.values.dialogs[this.id].modalBody = body;
                    lay.AddChild(scroller);
                    
                    var layBottom = app.CreateLayout("Linear", "Horizontal, Right, VCenter");
                    layBottom.SetSize(width-UI.Fw(10), UI.Fr(55));
                    layBottom.SetPadding(20, 0, 12, 0, "dp");
                        var closeBtn = UI.CreateButtonFlat("CANCEL", null, null, color);
                        closeBtn.SetMargins(0, 2.5, 0, 0, "dp");
                        layBottom.AddChild(closeBtn);
                        UI.values.objectIDs[closeBtn.id] = this.id;
                        closeBtn.SetOnTouch(function() {
                            var id = UI.values.objectIDs[this.id];
                            var cb = UI.values.dialogs[id].onOK;
                            if(cb) cb(false);
                            UI.values.dialogs[id].layout.Hide();
                            app.DestroyLayout(UI.values.dialogs[id].layout);
                        });
                        
                        var okBtn = UI.CreateButtonFlat(okText.toUpperCase(), null, null, color);
                        okBtn.SetMargins(0, 2.5, 0, 0, "dp");
                        layBottom.AddChild(okBtn);
                        UI.values.objectIDs[okBtn.id] = this.id;
                        okBtn.SetOnTouch(function() {
                            var id = UI.values.objectIDs[this.id];
                            var cb = UI.values.dialogs[id].onOK;
                            if(cb) cb(true);
                            UI.values.dialogs[id].layout.Hide();
                            app.DestroyLayout(UI.values.dialogs[id].layout);
                        });
                    lay.AddChild(layBottom);
                box.AddChild(lay);
            bool = bool==null ? true : bool;
            if(bool) {
                box.SetOnTouchUp(function() {
                    var id = UI.values.objectIDs[this.id];
                    var cb = UI.values.dialogs[id].onOK;
                    if(cb) cb(false);
                    this.Hide();
                    app.DestroyLayout(this);
                });
            }
            app.AddLayout(box);
            box.Animate("FadeIn");
        }
    },
    CreateAlertSimple: function(text, color, type) {
    	return new AlertSimple(text, color, type);
    	function AlertSimple(text, color, type) {
    	    this.id = UI.CreateID();
    	    UI.values.dialogs[this.id] = {layout: null, cb: null};
    	    
    	    this.SetOnTouchOK = function(cb) {
    	        UI.values.dialogs[this.id].cb = cb;
    	    }
    	    
    	    type = type || "rect";
        	type = type.toLowerCase();
        	type = type == "round" ? true: false;
        	color = color || this.colors.blue.blue;
        	var layout = app.CreateLayout("Linear", "VCenter, FillXY");
        	UI.values.dialogs[this.id].layout = layout;
        	UI.values.objectIDs[layout.id] = this.id;
        	layout.SetBackColor("#99000000");
            layout.SetOnTouchUp(function() {
            	var id = UI.values.objectIDs[this.id];
        		app.DestroyLayout(UI.values.dialogs[id].layout);
        		if(UI.values.dialogs[id].cb) UI.values.dialogs[id].cb(false);
            });
            layout.Hide();
            	var box = app.CreateLayout("Absolute");
                	var back = app.CreateButton("", null, null, "Custom");
                	back.SetStyle("#ffffff", "#ffffff", 10, 0, 0, 1);
                	back.Hide();
                	box.AddChild( back );
                
                	//container
                	var container = app.CreateLayout("Linear");
                	container.SetSize(UI.swdp-80, null, "dp");
                	container.SetPadding(25, 10, 20, 0, "dp");
                    container.SetBackColor("#ffffff");	
                    	var txt = UI.CreateTextParagraph(text, null, null, "MultiLine");
                    	txt.SetMargins(0, 10, 0, 10, "dp");
                    	txt.SetTextColor(UI.colors.grey.darken1);
                    	container.AddChild(txt);
                    	
                    	var okBtn = UI.CreateButtonFlat( "OKAY", 0.3, null, color);
                    	container.AddChild(okBtn);
                    	UI.values.objectIDs[okBtn.id] = this.id;
                    	okBtn.SetOnTouch(function() {
                    	    var id = UI.values.objectIDs[this.id];
                    		app.DestroyLayout(UI.values.dialogs[id].layout);
                    		if(UI.values.dialogs[id].cb) UI.values.dialogs[id].cb(true);
                    	});
                	box.AddChild(container);
            	layout.AddChild( box );
        
        	app.AddLayout(layout);
        	layout.Animate("FadeIn");
        	if(type) {
        		container.SetBackColor("#00000000");
        		container.SetPadding(25, 10, 20, 10, "dp");
        		back.SetSize(box.GetWidth(), box.GetHeight());
        		back.Show();
        	}  
    	}
    },
    CreateAlertStylish: function(text, icon, okText, color) {
    	return new AlertStylish(text, icon, okText, color);
    	function AlertStylish(text, icon, okText, color) {
    	    this.id = UI.CreateID();
    	    UI.values.dialogs[this.id] = {layout: null, cb: null};
    	    
    	    this.SetOnTouchOK = function(cb) {
        	    UI.values.dialogs[this.id].cb = cb;
        	}
    	    
        	color = color || UI.colors.blue.blue;
        	var layout = app.CreateLayout("Linear", "VCenter, FillXY");
        	UI.values.objectIDs[layout.id] = this.id;
        	UI.values.dialogs[this.id].layout = layout;
        	layout.SetBackColor("#99000000");
        	layout.Hide();
        	layout.SetOnTouchUp(function() {
        	    var id = UI.values.objectIDs[this.id];
        		app.DestroyLayout(UI.values.dialogs[id].layout);
        		if(UI.values.dialogs[id].cb) UI.values.dialogs[id].cb(false);
        	});
        		var box = app.CreateLayout("Absolute");
                	back = app.CreateButton("", null, null, "Custom");
                	back.SetPosition(0, UI.Fr(45));
                	back.SetStyle("#ffffff", "#ffffff", 5, 0, 0, 1);
                	box.AddChild( back );
                	
                	var icon = app.CreateButton(icon, null, null, "Custom");
                	icon.SetSize(100, 100, "dp");
                	icon.SetStyle("#ffffff", "#ffffff", 55, color, 0, 0);
                	icon.SetTextColor(color);
                	icon.SetTextSize(35);
                	icon.SetPosition(0.5-UI.Fw(90), 0);
                	icon.SetFontFile(UI.fonts.icon);
                	//icon.SetEnabled(false);
                	box.AddChild( icon );
                	
                	//container
                	var container = app.CreateLayout("Linear");
                	container.SetSize(UI.swdp-80, null, "dp");
                	container.SetPosition(0, UI.Fr(45));
                	container.SetPadding(25, 15, 20, 10, "dp");
                    	var txt = UI.CreateTextParagraph(text, null, null, "Left", UI.colors.grey.darken3);
                    	txt.SetMargins(0, 20, 0, 10, "dp");
                    	container.AddChild(txt);
                    	
                    	var okBtn = UI.CreateButtonFlat( okText || "OKAY", 0.3, null, color);
                    	container.AddChild(okBtn);
                    	UI.values.objectIDs[okBtn.id] = this.id;
                    	okBtn.SetOnTouch(function() {
                    		var id = UI.values.objectIDs[this.id];
                    		app.DestroyLayout(UI.values.dialogs[id].layout);
                    		if(UI.values.dialogs[id].cb) UI.values.dialogs[id].cb(true);
                    	});
                	box.AddChild(container);
                	
            	layout.AddChild( box );
        
        	app.AddLayout(layout);
        	layout.Animate("FadeIn");
        	back.SetSize(container.GetWidth(), container.GetHeight());
    	}
    },
    CreateAlert: function(text, icon, color) {
    	return new CreateAlert(text, icon, color);
    	function CreateAlert(text, icon, color) {
			color = color || UI.colors.blue.blue;
			this.id = UI.CreateID();
			UI.values.dialogs[this.id] = {layout: null, cb: null};
			
			this.SetOnClose = function(cb) {
				UI.values.dialogs[this.id].cb = cb;
			}
			
			var Layout = app.CreateLayout("Linear", "FillX");
			UI.values.dialogs[this.id].layout = Layout;
				var box = app.CreateLayout("Absolute");
				box.SetSize(UI.swdp-8, null, "dp");
				box.SetMargins(4, 5, 4, 0, "dp");	
					var Back = app.CreateButton("", null, null, "Custom");
					Back.SetStyle(color, color, 5, 0, 0, 0.5);
					box.AddChild( Back );
			
					var container = app.CreateLayout("Linear", "VCenter, Horizontal, Left");
					container.SetSize(UI.swdp-8, null, "dp");
					container.SetPadding(25, 15, 20, 25, "dp");
						var Icon = app.CreateText(icon.trim());
						Icon.SetTextColor("#ffffff");
					    Icon.SetTextSize(22);
						Icon.SetMargins(0, 0, 20, 0, "dp");
						Icon.SetFontFile(UI.fonts.icon);
						container.AddChild(Icon);
						
						var Text = UI.CreateTextParagraph(text.trim(), null, null, "Left, Multiline", "#ffffff");
						Text.SetMargins(0, 0, 20, 0, "dp");
						container.AddChild(Text);
					box.AddChild(container);
					
					var cbtn = app.CreateButton("close", null, null, "Custom");
					cbtn.SetSize(40, 40, "dp");
					cbtn.SetFontFile(UI.fonts.icon);
					cbtn.SetStyle(color, color, 30, 0, 0, 0);
					cbtn.SetTextColor("#000000");
					cbtn.SetPosition(1-UI.Fw(48), 0);
					box.AddChild(cbtn);
					UI.values.objectIDs[cbtn.id] = this.id;
					cbtn.SetOnTouch(function(){
						var id = UI.values.objectIDs[this.id];
						var layout = UI.values.dialogs[id].layout;
						layout.Animate("SlideToTop");
						app.DestroyLayout(layout);
						UI.values.layoutToRemove = null;
						clearTimeout(UI.values.timeOut);
						var cb = UI.values.dialogs[id].cb;
						if(cb) cb();
					});
				Layout.AddChild( box );
			Layout.Hide();
			app.AddLayout(Layout);
			Layout.Animate("SlideFromTop");
			Back.SetSize(box.GetWidth(), box.GetHeight());
			
			UI.values.layoutToRemove = Layout;
			UI.values.timeOut = setTimeout("UI.RemoveLayout()", 5000);
		}
    },
    
    // ===================== LIST =====================
    CreateList: function(list, width, height, textColor, iconColor) {
    	var bodyText = list[0].search(":") > -1 ? true :  false;
    	width = width || 1;
    	var list = app.CreateList(list, width, height, "Html, Fontawesome");
    	bodyText ? list.SetTextMargins(5, 0, 5, 0, "dp") : list.SetTextMargins(5, 8, 5, 8, "dp");
    	list.SetFontFile(this.fonts.regular);
    	list.SetTextSize1(18);
    	list.SetTextSize2(15);
    	list.SetTextColor1(textColor || "#000000");
    	list.SetTextColor2(iconColor || UI.colors.grey.darken1);
    	list.SetDivider(this.Fr(0.5), UI.colors.grey.lighten2);
    	list.SetEllipsize1("end");
    	list.SetIconMargins(15, 10, 5, 10, "dp");
    	list.SetIconSize(22);
    	return list;
    },
    CreateListInitialIcon: function(list, height, type, randomColor, color) {
    	return new CreateListInitialIcon(list, height, type, randomColor, color);
    	function CreateListInitialIcon(list, height, type, randomColor, color) {
			this.type = type || "elegant";
			this.randomColor = randomColor || false;
			this.color = color || UI.colors.blue.blue;
			this.list = [];
			this.listID = UI.CreateID();
			UI.values.lists[this.listID] = {list: [], titleID: [], iconID: [], rightIconID: [], layout: null, callback: null, controlCallback: null, iconCallback: null};
			
			this.List = app.CreateScroller(1, height);
				this.Layout = app.CreateLayout("Linear", "Left, FillX");
				this.List.AddChild(this.Layout);
				UI.values.lists[this.listID].layout = this.Layout;
			
			this.SetOnTouch = function(cb) {
				UI.values.lists[this.listID].callback = cb;
			}
			this.SetControlOnTouch = function(cb) {
				UI.values.lists[this.listID].controlCallback = cb;
			}
			this.SetIconOnTouch = function(cb) {
				UI.values.lists[this.listID].iconCallback = cb;
			}
			this.CreateIcon = function(i) {
				var color = randomColor ? UI.darkColors[ Math.floor( Math.random()*UI.darkColors.length ) ] : this.color;
				var txtClr = color;	
				this.type = this.type.toLowerCase();
				if(this.type == "fill") txtClr = "#ffffff";
				else color = UI.CreateLightColor(color);
				var btn = app.CreateButton(i, null, null, "Custom");
				btn.SetSize(54, 54, "dp");
				btn.SetStyle(color, color, 56, 0, 0, 0);
				btn.SetTextColor(txtClr);
				btn.SetFontFile(UI.fonts.icon);
				btn.SetTextSize(18);
				return btn;
			}
			this.CreateItem = function(snap, index, bool) {
				this.box1 = app.CreateLayout("Linear", "VCenter, Horizontal, Left, FillX");
				this.box1.SetPadding(10, 6, 0, 6, "dp");
					this.icon = this.CreateIcon(snap.title.trim().charAt(0).toUpperCase());
					this.icon.SetMargins(0, 2.5, 15, 0, "dp");
					this.box1.AddChild(this.icon);
					UI.values.listIDs[this.icon.id] = this.listID;
					UI.values.lists[this.listID].iconID[index] = this.icon.id;
					this.icon.SetOnTouch(function() {
						var listID = UI.values.listIDs[this.id];
						var cb = UI.values.lists[listID].iconCallback;
						if(cb) cb(UI.values.lists[listID].iconID.indexOf(this.id));
					});
							
					var clr = bool ? "#000000" : "#757575";
					var txt = "<b>"+snap.title+'</b><br><font color="'+ clr +'">'+snap.body+"</font>";
					this.title = UI.CreateTextParagraph(txt, null, null, "Left, Html, Multiline", null);
					this.title.SetSize(UI.swdp-(77+56), null, "dp");
					this.box1.AddChild(this.title);
					UI.values.listIDs[this.title.id] = this.listID;
					UI.values.lists[this.listID].titleID[index] = this.title.id;
					this.title.SetOnTouch(function(e) {
						var listID = UI.values.listIDs[this.id];
						var index = UI.values.lists[listID].titleID.indexOf(this.id);
						var row = UI.values.lists[listID].list[index].row;
						if(e.action == "Down") row.SetBackColor(UI.colors.grey.lighten3);
						if(e.action == "Move") row.SetBackColor("#ffffff");
						if(e.action == "Up") {
							row.SetBackColor("#ffffff");
							var cb = UI.values.lists[listID].callback;
							var s = this.GetText().split('\n');
							if(cb) cb(index, s[0], s[1]);
						}
					});
				
					this.rightIcon = app.CreateButton(snap.rightIcon.trim(), null, null, "Custom");
					this.rightIcon.SetSize(50, 50, "dp");
					this.rightIcon.SetTextSize(22);
					this.rightIcon.SetFontFile(UI.fonts.icon);
					this.rightIcon.SetTextColor("#000000");
					this.rightIcon.SetStyle("#ffffff", "#ffffff", 50, 0, 0, 0);
					this.box1.AddChild(this.rightIcon);
					UI.values.listIDs[this.rightIcon.id] = this.listID;
					UI.values.lists[this.listID].rightIconID[index] = this.rightIcon.id;
					this.rightIcon.SetOnTouch(function() {
						var listID = UI.values.listIDs[this.id];
						var cb = UI.values.lists[listID].controlCallback;
						if(cb) cb(UI.values.lists[listID].rightIconID.indexOf(this.id));
					});
				this.box1.Hide();
				this.Layout.AddChild(this.box1);
				UI.values.lists[this.listID].list[index] = {
					icon: this.icon,
					titleAndBody: this.title,
					row: this.box1,
					rightIcon: this.rightIcon
				};
				return this.box1;
			}
			this.SetItem = function(data, i) {
				this.list[i] = data;
				var txt = "<b>"+this.list[i].title+'</b><br><font color="#757575">'+this.list[i].body+"</font>";
				UI.values.lists[this.listID].list[i].titleAndBody.SetHtml(txt);
				UI.values.lists[this.listID].list[i].rightIcon.SetText(data.rightIcon.trim());
				var l = data.title.trim().charAt(0).toUpperCase();
				UI.values.lists[this.listID].list[i].icon.SetText(l);
			}
			this.SetTitleText = function(t, i) {
				this.list[i].title = t;
				var txt = "<b>"+this.list[i].title+'</b><br><font color="#757575">'+this.list[i].body+"</font>";
				UI.values.lists[this.listID].list[i].titleAndBody.SetHtml(txt);
			}
			this.SetBodyText = function(t, i) {
				this.list[i].body = t;
				var txt = "<b>"+this.list[i].title+'</b><br><font color="#757575">'+this.list[i].body+"</font>";
				UI.values.lists[this.listID].list[i].titleAndBody.SetHtml(txt);
			}
			this.SetRightIcon = function(t, i) {
				this.list[i].rightIcon = t;
				UI.values.lists[this.listID].list[i].rightIcon.SetText(t);
			}
			this.SetUnread = function(i, bool) {
				if(bool) {
					var txt = "<b>"+this.list[i].title+'</b><br>'+this.list[i].body;
					UI.values.lists[this.listID].list[i].titleAndBody.SetHtml(txt);
				} else {
					var txt = "<b>"+this.list[i].title+'</b><br><font color="#757575">'+this.list[i].body+"</font>";
					UI.values.lists[this.listID].list[i].titleAndBody.SetHtml(txt);
				}
			}
			this.RemoveItem = function(i) {
			    if(i < 0 || i >= this.list.length) return null;
				var row = UI.values.lists[this.listID].list[i].row;
				UI.values.layout["layout-to-remove"] = row;
				UI.values.layout["remove-from"] = this.Layout;
				row.Animate("SlideToRight", function() {UI.values.layout["remove-from"].RemoveChild(UI.values.layout["layout-to-remove"]);});
				this.list.splice(i, 1);
				UI.values.lists[this.listID].list.splice(i, 1);
				UI.values.lists[this.listID].titleID.splice(i, 1);
				UI.values.lists[this.listID].iconID.splice(i, 1);
				UI.values.lists[this.listID].rightIconID.splice(i, 1);
			}
			this.PopItem = function() {
				this.RemoveItem(this.list.length-1);
			}
			this.ShiftItem = function() {
				this.RemoveItem(0);
			}
			this.AppendItems = function(snap, bool) {
				var index = this.list.length;
				var rows = [];
				for(var i = 0; i<snap.length; i++) {
					this.list.push(snap[i]);
					rows[i] = this.CreateItem(snap[i], index+i, bool);
				}
				for(var i = 0; i<rows.length; i++) {
					rows[i].Animate("SlideFromRight");
				}
				rows = null;
				this.created = true;
			}
			this.GetList = function() {
				return this.list;
			}
			this.AppendItems(list);
		}
    },
    CreateListMaterialIcon: function(list, height, type, randomColor, color) {
    	return new CreateListMaterialIcon(list, height, type, randomColor, color);
    	function CreateListMaterialIcon(list, height, type, randomColor, color) {
			this.type = type || "elegant";
			this.randomColor = randomColor || false;
			this.color = color || UI.colors.blue.blue;
			this.list = [];
			this.listID = UI.CreateID();
			UI.values.lists[this.listID] = {list: [], titleID: [], iconID: [], rightIconID: [], layout: null, callback: null, controlCallback: null, iconCallback: null};
			
			this.List = app.CreateScroller(1, height);
				this.Layout = app.CreateLayout("Linear", "Left, FillX");
				this.List.AddChild(this.Layout);
				UI.values.lists[this.listID].layout = this.Layout;
			
			this.SetOnTouch = function(cb) {
				UI.values.lists[this.listID].callback = cb;
			}
			this.SetControlOnTouch = function(cb) {
				UI.values.lists[this.listID].controlCallback = cb;
			}
			this.SetIconOnTouch = function(cb) {
				UI.values.lists[this.listID].iconCallback = cb;
			}
			this.CreateIcon = function(i) {
				var color = randomColor ? UI.darkColors[ Math.floor( Math.random()*UI.darkColors.length ) ] : this.color;
				var txtClr = color;
				this.type = this.type.toLowerCase();
				if(this.type == "fill") txtClr = "#ffffff";
				else color = UI.CreateLightColor(color);
				
				var btn = app.CreateButton(i, null, null, "Custom");
				btn.SetSize(54, 54, "dp");
				btn.SetStyle(color, color, 56, 0, 0, 0);
				btn.SetTextColor(txtClr);
				btn.SetFontFile(UI.fonts.icon);
				btn.SetTextSize(20);
				return btn;
			}
			this.CreateItem = function(snap, index, bool) {
				this.box1 = app.CreateLayout("Linear", "VCenter, Horizontal, Left, FillX");
				this.box1.SetPadding(10, 6, 0, 6, "dp");
					this.icon = this.CreateIcon(snap.icon.trim());
					this.icon.SetMargins(0, 2.5, 15, 0, "dp");
					this.box1.AddChild(this.icon);
					UI.values.listIDs[this.icon.id] = this.listID;
					UI.values.lists[this.listID].iconID[index] = this.icon.id;
					this.icon.SetOnTouch(function() {
						var listID = UI.values.listIDs[this.id];
						var cb = UI.values.lists[listID].controlCallback;
						if(cb) cb(UI.values.lists[listID].iconID.indexOf(this.id));
					});
				
					var clr = bool ? "#000000" : "#757575";
					var txt = "<b>"+snap.title+'</b><br><font color="'+ clr +'">'+snap.body+"</font>";
					this.title = UI.CreateTextParagraph(txt, null, null, "Left, Html, Multiline", null);
					this.title.SetSize(UI.swdp-(77+56), null, "dp");
					this.box1.AddChild(this.title);
					UI.values.listIDs[this.title.id] = this.listID;
					UI.values.lists[this.listID].titleID[index] = this.title.id;
					this.title.SetOnTouch(function(e) {
						var listID = UI.values.listIDs[this.id];
						var index = UI.values.lists[listID].titleID.indexOf(this.id);
						var row = UI.values.lists[listID].list[index].row;
						if(e.action == "Down") row.SetBackColor(UI.colors.grey.lighten3);
						if(e.action == "Move") row.SetBackColor("#ffffff");
						if(e.action == "Up") {
							row.SetBackColor("#ffffff");
							var cb = UI.values.lists[listID].callback;
							var s = this.GetText().split('\n');
							if(cb) cb(index, s[0], s[1]);
						}
					});
				
					this.rightIcon = app.CreateButton(snap.rightIcon.trim(), null, null, "Custom");
					this.rightIcon.SetSize(50, 50, "dp");
					this.rightIcon.SetTextSize(22);
					this.rightIcon.SetFontFile(UI.fonts.icon);
					this.rightIcon.SetTextColor("#000000");
					this.rightIcon.SetStyle("#ffffff", "#ffffff", 50, 0, 0, 0);
					this.box1.AddChild(this.rightIcon);
					UI.values.listIDs[this.rightIcon.id] = this.listID;
					UI.values.lists[this.listID].iconID[index] = this.rightIcon.id;
					this.rightIcon.SetOnTouch(function() {
						var listID = UI.values.listIDs[this.id];
						var cb = UI.values.lists[listID].controlCallback;
						if(cb) cb(UI.values.lists[listID].rightIconID.indexOf(this.id));
					});
				this.box1.Hide();
				this.Layout.AddChild(this.box1);
				UI.values.lists[this.listID].list[index] ={
					icon: this.icon,
					titleAndBody: this.title,
					row: this.box1,
					rightIcon: this.rightIcon
				};
				return this.box1;
			}
			this.SetItem = function(data, i) {
				this.list[i] = data;
				var txt = "<b>"+this.list[i].title+'</b><br><font color="#757575">'+this.list[i].body+"</font>";
				UI.values.lists[this.listID].list[i].titleAndBody.SetHtml(txt);
				UI.values.lists[this.listID].list[i].rightIcon.SetText(data.rightIcon.trim());
				UI.values.lists[this.listID].list[i].icon.SetText(data.icon);
			}
			this.SetTitleText = function(t, i) {
				this.list[i].title = t;
				var txt = "<b>"+this.list[i].title+'</b><br><font color="#757575">'+this.list[i].body+"</font>";
				UI.values.lists[this.listID].list[i].titleAndBody.SetHtml(txt);
			}
			this.SetBodyText = function(t, i) {
				this.list[i].body = t;
				var txt = "<b>"+this.list[i].title+'</b><br><font color="#757575">'+this.list[i].body+"</font>";
				UI.values.lists[this.listID].list[i].titleAndBody.SetHtml(txt);
			}
			this.SetRightIcon = function(t, i) {
				this.list[i].rightIcon = t;
				UI.values.lists[this.listID].list[i].rightIcon.SetText(t);
			}
			this.SetUnread = function(i, bool) {
				if(bool) {
					var txt = "<b>"+this.list[i].title+'</b><br>'+this.list[i].body;
					UI.values.lists[this.listID].list[i].titleAndBody.SetHtml(txt);
				} else {
					var txt = "<b>"+this.list[i].title+'</b><br><font color="#757575">'+this.list[i].body+"</font>";
					UI.values.lists[this.listID].list[i].titleAndBody.SetHtml(txt);
				}
			}
			this.SetIcon = function(icon, i) {
				this.list[i].icon = icon;
				UI.values.lists[this.listID].list[i].icon.SetText(icon);
			}
			this.RemoveItem = function(i) {
			    if(i < 0 || i >= this.list.length) return null;
				var row = UI.values.lists[this.listID].list[i].row;
				UI.values.layout["layout-to-remove"] = row;
				UI.values.layout["remove-from"] = this.Layout;
				row.Animate("SlideToRight", function() {UI.values.layout["remove-from"].RemoveChild(UI.values.layout["layout-to-remove"]);});
				this.list.splice(i, 1);
				UI.values.lists[this.listID].list.splice(i, 1);
				UI.values.lists[this.listID].titleID.splice(i, 1);
				UI.values.lists[this.listID].iconID.splice(i, 1);
				UI.values.lists[this.listID].rightIconID.splice(i, 1);
			}
			this.PopItem = function() {
				this.RemoveItem(this.list.length-1);
			}
			this.ShiftItem = function() {
				this.RemoveItem(0);
			}
			this.AppendItems = function(snap, bool) {
				var index = this.list.length;
				var rows = [];
				for(var i = 0; i<snap.length; i++) {
					this.list.push(snap[i]);
					rows[i] = this.CreateItem(snap[i], index+i, bool);
				}
				for(var i = 0; i<rows.length; i++) {
					rows[i].Animate("SlideFromRight");
				}
				rows = null;
				this.created = true;
			}
			this.GetList = function() {
				return this.list;
			}
			this.AppendItems(list);
		}
    },
    CreateListSimple: function(list, height, divider, backColor) {
    	return new CreateListSimple(list, height, divider, backColor);
    	function CreateListSimple(list, height, bool, backColor) {
			this.list = [];
			this.backColor = backColor || "#ffffff";
			this.boolDivider = bool;
			this.listID = UI.CreateID();
			UI.values.lists[this.listID] = {list:[], row:[], iconID: [], titleID: [], callback:null, color: null};
			UI.values.lists[this.listID].color = this.backColor;

			this.List = app.CreateScroller(1, height);
				this.Layout = app.CreateLayout("Linear", "Left, FillX");
				this.List.AddChild(this.Layout);
				UI.values.lists[this.listID].layout = this.Layout;
			
			this.SetOnTouch = function(cb) {
				UI.values.lists[this.listID].callback = cb;
			}
			this.CreateIcon = function(icon, clr) {
				var btn = app.CreateButton(icon.trim(), null, null, "Custom");
				btn.SetSize(45, 45, "dp");
				btn.SetStyle("#00ffffff", "#00ffffff", 45, "#e0e0e0", 1, 0);
				btn.SetTextColor(clr);
				btn.SetTextSize(16, "dp");
				btn.SetFontFile(UI.fonts.icon);
				return btn;
			}
			this.CreateItem = function(snap, index, bool) {
				this.box1 = app.CreateLayout("Linear", "VCenter, Horizontal, Left, FillX");
					this.icon = this.CreateIcon(snap.icon, snap.color? snap.color.trim() : UI.colors.blue.blue);
					this.icon.SetMargins(15, 2.5, 15, 0, "dp");
					this.box1.AddChild(this.icon);
					UI.values.lists[this.listID].iconID[index] = this.icon.id;
					
					var ct = app.CreateLayout("Linear");
					ct.SetSize(UI.swdp-75, null, "dp");
						this.title = UI.CreateTextParagraph(snap.title.trim(), null, null, "Left", null, "Medium");
						this.title.SetSize(UI.swdp-75, null, "dp");
						this.title.SetPadding(0, 20, 0, 20, "dp");
						ct.AddChild(this.title);
						UI.values.listIDs[this.title.id] = this.listID;
						UI.values.lists[this.listID].titleID[index] = this.title.id;
						this.boolDivider ? ct.AddChild(UI.CreateDivider()) : null;
						this.title.SetOnTouch(function(e) {
							var listID = UI.values.listIDs[this.id];
							var index = UI.values.lists[listID].titleID.indexOf(this.id);
							var row = UI.values.lists[listID].list[index].row;
							if(e.action == "Down") row.SetBackColor("#10000000");
							if(e.action == "Move") row.SetBackColor("#00000000");
							if(e.action == "Up") {
								row.SetBackColor("#00000000");
								var cb = UI.values.lists[listID].callback;
								if(cb) cb(index, this.GetText());
							}
						});
					this.box1.AddChild(ct);
				this.box1.Hide();
				this.Layout.AddChild(this.box1);
				UI.values.lists[this.listID].list[index] = {
					title: this.title,
					icon: this.icon,
					row: this.box1
				};
				return this.box1;
			}
			this.AppendItems = function(snap, bool) {
				var index = this.list.length;
				var rows = [];
				for(var i = 0; i<snap.length; i++) {
					this.list.push(snap[i]);
					rows[i] = this.CreateItem(snap[i], index+i, bool);
				}
				for(var i = 0; i<rows.length; i++) rows[i].Animate("SlideFromRight");
				rows = null;
				this.created = true;
			}
			this.GetList = function() {
				return this.list;
			}
			this.AppendItems(list);
		}
    },
    CreateListWithAvatar: function(data, height, color) {
    	return new CreateListWithAvatar(data, height, color);
    	function CreateListWithAvatar(list, height, color) {
			this.color = color || null;
			this.list = [];
			this.listID = UI.CreateID();
			UI.values.lists[this.listID] = {list: [], titleID: [], iconID: [], rightIconID: [], layout: null, callback: null, controlCallback: null, iconCallback: null, button: null};
			
			this.List = app.CreateScroller(1, height);
				this.Layout = app.CreateLayout("Linear", "Left, FillX");
				this.List.AddChild(this.Layout);
				UI.values.lists[this.listID].layout = this.Layout;
			    
			this.SetOnTouch = function(cb) {
				UI.values.lists[this.listID].callback = cb;
			}
			this.SetControlOnTouch = function(cb) {
				UI.values.lists[this.listID].controlCallback = cb;
			}
			this.SetIconOnTouch = function(cb) {
				UI.values.lists[this.listID].iconCallback = cb;
			}
			this.CreateImage = function(img, bool) {
				var color = this.color || UI.darkColors[ Math.floor( Math.random()*UI.darkColors.length ) ];
				var image = app.CreateImage(null, UI.Fw(40), UI.Fr(40));
				if( bool ) image.SetImage(img);
				else {
					image.SetPaintColor( color );
					image.DrawCircle( 0.5, 0.5, 0.5);
					image.SetPaintColor( "#ffffff"  );
					image.SetTextSize(22);
					image.DrawText( img, 0.32, 0.675 );
				}
				return image;
			}
			this.CreateItem = function(ls, index, bool) {
				this.box1 = app.CreateLayout("Linear", "VCenter, Horizontal, Left, FillX");
				this.box1.SetPadding(0, 12.5, 0, 12.5, "dp");
					var img = ls.image ? ls.image.trim() : ls.title.trim().charAt(0).toUpperCase();
					this.icon = this.CreateImage(img, ls.image ? true : false );
					this.icon.SetMargins(15, 0, 15, 0, "dp");
					this.box1.AddChild(this.icon);
					UI.values.listIDs[this.icon.id] = this.listID;
					UI.values.lists[this.listID].iconID[index] = this.icon.id;
					this.icon.SetOnTouch(function() {
						var listID = UI.values.listIDs[this.id];
						var cb = UI.values.lists[listID].controlCallback;
						if(cb) cb(UI.values.lists[listID].iconID.indexOf(this.id));
					});
					
					var clr = bool ? "#000000" : "#757575";
					var txt = "<b>"+ls.title+'</b><br><font color="'+ clr +'">'+ls.body+"</font>";
					this.title = UI.CreateTextParagraph(txt, null, null, "Left, Html, Multiline", "#000000");
					this.title.SetEllipsize("end");
					this.title.SetSize(UI.swdp-120, null, "dp");
					this.box1.AddChild(this.title);
					UI.values.listIDs[this.title.id] = this.listID;
					UI.values.lists[this.listID].titleID[index] = this.title.id;
					this.title.SetOnTouch(function(e) {
						var listID = UI.values.listIDs[this.id];
						var index = UI.values.lists[listID].titleID.indexOf(this.id);
						var row = UI.values.lists[listID].list[index].row;
						if(e.action == "Down") row.SetBackColor(UI.colors.grey.lighten3);
						if(e.action == "Move") row.SetBackColor("#ffffff");
						if(e.action == "Up") {
							row.SetBackColor("#ffffff");
							var cb = UI.values.lists[listID].callback;
							var s = this.GetText().split('\n');
							if(cb) cb(index, s[0], s[1]);
						}
					});
			
					this.rightIcon = app.CreateButton(ls.rightIcon ? ls.rightIcon.trim() : "", null, null, "Custom");
					this.rightIcon.SetSize(50, 50, "dp");
					this.rightIcon.SetTextSize(22);
					this.rightIcon.SetFontFile(UI.fonts.icon);
					this.rightIcon.SetTextColor("#000000");
					this.rightIcon.SetStyle("#40ffffff", "#40ffffff", 50, 0, 0, 0);
					this.box1.AddChild(this.rightIcon);
					//save values
					UI.values.listIDs[this.rightIcon.id] = this.listID;
					UI.values.lists[this.listID].rightIconID[index] = this.rightIcon.id;
					this.rightIcon.SetOnTouch(function() {
						var listID = UI.values.listIDs[this.id];
						var cb = UI.values.lists[listID].controlCallback;
						if(cb) cb(UI.values.lists[listID].rightIconID.indexOf(this.id));
					});
				this.box1.Hide();
				this.Layout.AddChild(this.box1);
				UI.values.lists[this.listID].list[index] ={
					image: this.icon,
					titleAndBody: this.title,
					row: this.box1,
					rightIcon: this.rightIcon
				};
				return this.box1;
			}
			this.SetItem = function(data, i) {
			    if(i < 0 || i >= this.list.length) return null;
				this.list[i] = data;
				var txt = "<b>"+this.list[i].title+'</b><br><font color="#757575">'+this.list[i].body+"</font>";
				UI.values.lists[this.listID].list[i].titleAndBody.SetHtml(txt);
				UI.values.lists[this.listID].list[i].rightIcon.SetText(data.rightIcon.trim());
				UI.values.lists[this.listID].list[i].image.SetImage(data.image);
			}
			this.SetTitleText = function(t, i) {
			    if(i < 0 || i >= this.list.length) return null;
				this.list[i].title = t;
				var txt = "<b>"+this.list[i].title+'</b><br><font color="#757575">'+this.list[i].body+"</font>";
				UI.values.lists[this.listID].list[i].titleAndBody.SetHtml(txt);
			}
			this.SetBodyText = function(t, i) {
			    if(i < 0 || i >= this.list.length) return null;
				this.list[i].body = t;
				var txt = "<b>"+this.list[i].title+'</b><br><font color="#757575">'+this.list[i].body+"</font>";
				UI.values.lists[this.listID].list[i].titleAndBody.SetHtml(txt);
			}
			this.SetRightIcon = function(t, i) {
			    if(i < 0 || i >= this.list.length) return null;
				this.list[i].rightIcon = t;
				UI.values.lists[this.listID].list[i].rightIcon.SetText(t);
			}
			this.SetUnread = function(i, bool) {
			    if(i < 0 || i >= this.list.length) return null;
				if(bool) {
					var txt = "<b>"+this.list[i].title+'</b><br>'+this.list[i].body;
					UI.values.lists[this.listID].list[i].titleAndBody.SetHtml(txt);
				} else {
					var txt = "<b>"+this.list[i].title+'</b><br><font color="#757575">'+this.list[i].body+"</font>";
					UI.values.lists[this.listID].list[i].titleAndBody.SetHtml(txt);
				}
			}
			this.SetImage = function(img, i) {
			    if(i < 0 || i >= this.list.length) return null;
				this.list[i].image = img;
				UI.values.lists[this.listID].list[i].image.SetImage(img);
			}
			this.RemoveItem = function(i) {
			    if(i < 0 || i >= this.list.length) return null;
				var row = UI.values.lists[this.listID].list[i].row;
				UI.values.layout["layout-to-remove"] = row;
				UI.values.layout["remove-from"] = this.Layout;
				row.Animate("SlideToRight", function() {UI.values.layout["remove-from"].RemoveChild(UI.values.layout["layout-to-remove"]);});
				this.list.splice(i, 1);
				UI.values.lists[this.listID].list.splice(i, 1);
				UI.values.lists[this.listID].titleID.splice(i, 1);
				UI.values.lists[this.listID].iconID.splice(i, 1);
				UI.values.lists[this.listID].rightIconID.splice(i, 1);
			}
			this.PopItem = function() {
				this.RemoveItem(this.list.length-1);
			}
			this.ShiftItem = function() {
				this.RemoveItem(0);
			}
			this.AppendItems = function(snap, bool) {
				var index = this.list.length;
				var rows = [];
				for(var i = 0; i<snap.length; i++) {
					this.list.push(snap[i]);
					rows[i] = this.CreateItem(snap[i], index+i, bool);
				}
				for(var i = 0; i<rows.length; i++) {
					rows[i].Animate("SlideFromRight");
				}
				rows = null;
				this.created = true;
			}
			this.GetList = function() {
				return this.list;
			}
			this.AppendItems(list);
		}
    },
    CreateListModern: function(ls, height, color) {
    	return new CreateListModern(ls, height, color);
    	function CreateListModern(list, height, color) {
			this.color = color || UI.colors.blue.blue;
			this.list = [];
			this.created = false;
			this.listID = UI.CreateID();
			UI.values.lists[this.listID] = {list: [], titleID: [], iconID: [], noteID: [], layout: null, callback: null, iconCallback: null};
			
			this.List = app.CreateScroller(1, height);
				this.Layout = app.CreateLayout("Linear", "Left, FillX");
				this.List.AddChild(this.Layout);
				UI.values.lists[this.listID].layout = this.Layout;
			
			this.SetOnTouch = function(cb) {
				UI.values.lists[this.listID].callback = cb;
			}
			this.SetIconOnTouch = function(cb) {
				UI.values.lists[this.listID].iconCallback = cb;
			}
			this.CreateImage = function(img, bool) {
				var color = this.color ||  UI.darkColors[ Math.floor( Math.random()*UI.darkColors.length ) ];
				var image = app.CreateImage(null, UI.Fw(40), UI.Fr(40));
				if( bool ) image.SetImage(img);
				else {
					image.SetPaintColor( color );
					image.DrawCircle( 0.5, 0.5, 0.5);
					image.SetTextSize(24);
					image.SetPaintColor( "#ffffff"  );
					image.DrawText( img, 0.32, 0.675 );
				}
				return image;
			}
			this.CreateItem = function(snap, index, bool) {
				this.row = app.CreateLayout("Linear", "Horizontal, Left, FillX");
				this.row.SetPadding(0, 12.5, 0, 12.5, "dp");
					var img = snap.image ? snap.image.trim() : snap.title.trim().charAt(0).toUpperCase();
					this.icon = this.CreateImage(img, snap.image ? true : false );
					this.icon.SetMargins(15, 2.5, 15, 0, "dp");
					this.row.AddChild(this.icon);
					UI.values.listIDs[this.icon.id] = this.listID;
					UI.values.lists[this.listID].iconID[index] = this.icon.id;
					this.icon.SetOnTouch(function() {
						var listID = UI.values.listIDs[this.id];
						var cb = UI.values.lists[listID].iconCallback;
						if(cb) cb(UI.values.lists[listID].iconID.indexOf(this.id));
					});
					
					var clr = bool ? "#000000" : "#757575";
					var txt = "<b>"+snap.title+'</b><br><font color="'+clr+'">'+snap.body+"</font>";
					this.title = UI.CreateTextParagraph(txt, null, null, "Left, Html, Multiline", null);
					this.title.SetEllipsize("end");
					this.title.SetSize(UI.swdp-130, null, "dp");
					this.row.AddChild(this.title);
					UI.values.listIDs[this.title.id] = this.listID;
					UI.values.lists[this.listID].titleID[index] = this.title.id;
					this.title.SetOnTouch(function(e) {
						var listID = UI.values.listIDs[this.id];
						var index = UI.values.lists[listID].titleID.indexOf(this.id);
						var row = UI.values.lists[listID].list[index].row;
						if(e.action == "Down") row.SetBackColor(UI.colors.grey.lighten3);
						if(e.action == "Move") row.SetBackColor("#ffffff");
						if(e.action == "Up") {
							row.SetBackColor("#ffffff");
							var cb = UI.values.lists[listID].callback;
							var s = this.GetText().split('\n');
							if(cb) cb(index, s[0], s[1]);
						}
					});
						
					this.noteText = app.CreateText(snap.note, UI.Fw(60), null, "Right");
					this.noteText.SetTextSize(12);
					this.noteText.SetPadding(0, 0, 5, 0, "dp");
					this.noteText.SetTextColor(UI.colors.grey.darken2);
					this.row.AddChild( this.noteText );
					UI.values.lists[this.listID].noteID[index] = this.noteText.id;
				this.row.Hide();
				this.Layout.AddChild(this.row);
					
				UI.values.lists[this.listID].list[index] = {
					row:  this.row,
					image: this.icon,
					titleAndBody:this.title,
					note: this.noteText,
				};
				return this.row;
			}
			this.SetItem = function(data, i) {
				this.list[i] = data;
				var txt = "<b>"+this.list[i].title+'</b><br><font color="#757575">'+this.list[i].body+"</font>";
				UI.values.lists[this.listID].list[i].titleAndBody.SetHtml(txt);
				UI.values.lists[this.listID].list[i].note.SetText(data.note.trim());
				UI.values.lists[this.listID].list[i].image.SetImage(data.image);
			}
			this.SetTitleText = function(t, i) {
				this.list[i].title = t;
				var txt = "<b>"+this.list[i].title+'</b><br><font color="#757575">'+this.list[i].body+"</font>";
				UI.values.lists[this.listID].list[i].titleAndBody.SetHtml(txt);
			}
			this.SetBodyText = function(t, i) {
				this.list[i].body = t;
				var txt = "<b>"+this.list[i].title+'</b><br><font color="#757575">'+this.list[i].body+"</font>";
				UI.values.lists[this.listID].list[i].titleAndBody.SetHtml(txt);
			}
			this.SetNoteText = function(t, i) {
				this.list[i].note = t;
				UI.values.lists[this.listID].list[i].note.SetText(t);
			}
			this.SetUnread = function(i, bool) {
				if(bool) {
					var txt = "<b>"+this.list[i].title+'</b><br>'+this.list[i].body;
					UI.values.lists[this.listID].list[i].titleAndBody.SetHtml(txt);
				} else {
					var txt = "<b>"+this.list[i].title+'</b><br><font color="#757575">'+this.list[i].body+"</font>";
					UI.values.lists[this.listID].list[i].titleAndBody.SetHtml(txt);
				}
			}
			this.SetImage = function(img, i) {
				this.list[i].image = img;
				UI.values.lists[this.listID].list[i].image.SetImage(img);
			}
			this.RemoveItem = function(i) {
			    if(i < 0 || i >= this.list.length) return null;
				var row = UI.values.lists[this.listID].list[i].row;
				UI.values.layout["layout-to-remove"] = row;
				UI.values.layout["remove-from"] = this.Layout;
				row.Animate("SlideToRight", function() {UI.values.layout["remove-from"].RemoveChild(UI.values.layout["layout-to-remove"]);});
				this.list.splice(i, 1);
				UI.values.lists[this.listID].list.splice(i, 1);
				UI.values.lists[this.listID].titleID.splice(i, 1);
				UI.values.lists[this.listID].iconID.splice(i, 1);
				UI.values.lists[this.listID].noteID.splice(i, 1);
			}
			this.PopItem = function() {
				this.RemoveItem(this.list.length-1);
			}
			this.ShiftItem = function() {
				this.RemoveItem(0);
			}
			this.AppendItems = function(snap, bool) {
				var index = this.list.length;
				var rows = [];
				for(var i = 0; i<snap.length; i++) {
					this.list.push(snap[i]);
					rows[i] = this.CreateItem(snap[i], index+i, bool);
				}
				for(var i = 0; i<rows.length; i++) {
					rows[i].Animate("SlideFromRight");
				}
				rows = null;
				this.created = true;
			}
			this.GetList = function() {
				return this.list;
			}
			this.AppendItems(list);
		}
    },
    
    // ===================== RADIO =====================
    CreateRadio: function(list, width, height, color) {
        return new Radio(list, width, height, color);
        function Radio(list, width, height, color) {
            this.id = UI.CreateID();
    	    UI.values.radioSwitchCheckbox[this.id] = {layout: null, cb: null, checkItem: -1};
            
            this.SetMargins = function(l, t, r, b, mode) {
                this.Radio.SetMargins(l, t, r, b, mode);
            }
            this.SetPosition = function(l, t) {
                this.Radio.SetPosition(l, t); 
            }
            this.SetOnTouch = function(cb) {
                UI.values.radioSwitchCheckbox[this.id].cb = cb;
            }
            this.GetCheckItem = function() {
                var checkItem = UI.values.radioSwitchCheckbox[this.id].checkItem;
                if(checkItem == -1) {
                    return null;
                }
                var item = this.Radio.GetItemByIndex(checkItem);
                return item.title+","+checkItem;
            }
            this.CheckItemByIndex = function(index) {
                var checkItem = UI.values.radioSwitchCheckbox[this.id].checkItem;
                this.Radio.SetItemByIndex(checkItem, null, null, "[fa-circle-thin]");
                this.Radio.SetItemByIndex(index, null, null, "[fa-circle]");
                UI.values.radioSwitchCheckbox[this.id].checkItem = index;
            }
            
            var color = color || UI.colors.blue.blue;
            var list = list.split(",");
            list.forEach(function(item, i) {
                list[i] = item+":[fa-circle-thin]".trim();
            });
            this.Radio = app.CreateList(list, width, height, "Fontawesome");
            this.Radio.SetDivider(0, "#00000000");
            this.Radio.SetIconSize(22);
            this.Radio.SetIconMargins(15, 0, 0, 0, "dp");
            this.Radio.SetTextMargins(0, 7, 0, 7, "dp");
            this.Radio.SetTextColor1("#000000");
            this.Radio.SetTextColor2(color);
            this.Radio.SetFontFile(UI.fonts.regular);
            
            UI.values.objectIDs[this.Radio.id] = this.id;
            this.Radio.SetOnTouch(function(a, b, c, d) {
                var id = UI.values.objectIDs[this.id];
                var checkItem = UI.values.radioSwitchCheckbox[id].checkItem;
                this.SetItemByIndex(checkItem, null, null, "[fa-circle-thin]");
                this.SetItemByIndex(d, null, null, "[fa-circle]");
                UI.values.radioSwitchCheckbox[id].checkItem = d;
                if(UI.values.radioSwitchCheckbox[id].cb) UI.values.radioSwitchCheckbox[id].cb(a, d);
            });
        }
    },
    CreateRadioMaterial: function(list, width, height, color, backColor, orientation) {
        return new RadioMaterial(list, width, height, color, orientation);
        function RadioMaterial(list, width, height, color, orientation) {
            color = color || UI.colors.blue.blue;
            backColor = backColor || "#ffffff";
            list = list.split(",");
            
            this.id = UI.CreateID();
    	    UI.values.radioSwitchCheckbox[this.id] = {layout: null, radios: [], list: list, cb: null, checkItem: -1};
            
            this.SetMargins = function(l, t, r, b, mode) {
                this.Radio.SetMargins(l, t, r, b, mode);
            }
            this.SetPosition = function(l, t) {
                this.Radio.SetPosition(l, t); 
            }
            this.SetOnTouch = function(cb) {
                UI.values.radioSwitchCheckbox[this.id].cb = cb;
            }
            this.GetCheckItem = function() {    // edit this
                var checkItem = UI.values.radioSwitchCheckbox[this.id].checkItem;
                if(checkItem == -1) {
                    return null;
                }
                var title = UI.values.radioSwitchCheckbox[this.id].list[checkItem];
                return title+","+checkItem;
            }
            this.CheckItemByIndex = function(index) { // edit this
                var checkItem = UI.values.radioSwitchCheckbox[this.id].checkItem;
                if(checkItem > -1) UI.values.radioSwitchCheckbox[this.id].radios[checkItem].SetText("radio_button_unchecked");
                UI.values.radioSwitchCheckbox[this.id].radios[index].SetText("radio_button_checked");
                UI.values.radioSwitchCheckbox[this.id].checkItem = index;
            }
            this.Show = function() {
                this.Radio.Show();
            }
            this.Hide = function() {
                this.Radio.Hide();
            }
            this.Toggle = function() {
                if(this.Radio.GetVisibility() == "Show") {
                    this.Radio.Hide();
                } else {
                    this.Radio.Show();
                }
            }
            
            var vert = false;
            if(orientation && orientation.toLowerCase() == "vertical") {
                orientation+= ", Left";
                vert = true;
            }
            
            this.Radio = app.CreateLayout("Linear");
            this.Radio.SetSize(width, height);
                var scroller = app.CreateScroller(width, height);
                var lay = app.CreateLayout("Linear", orientation || "Vertical, Left");
                    for(var i = 0; i < list.length; i++) {
                        var box = app.CreateLayout("Linear", "Horizontal, Left, VCenter");
                        box.SetSize(-1, UI.Fr(50));
                            var radio = app.CreateButton("radio_button_unchecked", null, null, "Custom");
                            radio.SetSize(55, 55, "dp");
    	                    radio.SetMargins(0, 3, 0, 0, "dp");
    	                    radio.SetTextSize(25, "dp");
    	                    radio.SetStyle("#ffffff", "#ffffff", 50, 0, 0, 0);
    	                    radio.SetTextColor(color);
    	                    radio.SetFontFile(UI.fonts.icon);
    	                    box.AddChild(radio);
    	                    UI.values.objectIDs[radio.id] = this.id+","+i;
    	                    UI.values.radioSwitchCheckbox[this.id].radios[i] = radio;
    	                    radio.SetOnTouch(function() {
    	                        var snap = UI.values.objectIDs[this.id].split(",");
    	                        var id = snap[0];
    	                        var index = snap[1];
    	                        var checkItem = UI.values.radioSwitchCheckbox[id].checkItem;
    	                        if(checkItem > -1) UI.values.radioSwitchCheckbox[id].radios[checkItem].SetText("radio_button_unchecked");
    	                        this.SetText("radio_button_checked");
    	                        UI.values.radioSwitchCheckbox[id].checkItem = index;
    	                        var title = UI.values.radioSwitchCheckbox[id].list[index];
    	                        var cb = UI.values.radioSwitchCheckbox[id].cb;
    	                        if(cb) cb(title, index);
    	                    });
                            
                            var text = app.CreateText( list[i].trim() );
        	                text.SetTextColor("#000000");
        	                text.SetFontFile(UI.fonts.regular);
        	                text.SetTextSize(18);
        	                if(!vert) text.SetMargins(0, 0, 12, 0, "dp");
        	                box.AddChild(text);
        	                /*
        	                UI.values.objectIDs[text.id] = this.id;
        	                UI.values.radioSwitchCheckbox[this.id].radios[text.id] = radio;
        	                text.SetOnTouchDown(function() {
        	                    var id = UI.values.objectIDs[this.id];
                                app.SimulateTouch(UI.values.radioSwitchCheckbox[id].radios[this.id]);
        	                });
        	                */
                        lay.AddChild(box);
                    }
                scroller.AddChild(lay);
                this.Radio.AddChild(scroller);
        }
    },
    
    // ===================== SWITCHES =====================
    CreateSwitch: function(value, color) {
        return new Switch(value, color);
        function Switch(value, color) {
            var color = color || UI.colors.blue.blue;
            
            this.id = UI.CreateID();
    	    UI.values.radioSwitchCheckbox[this.id] = {cb: null, color: color, checked: value};
    	    
    	    this.SetOnTouch = function(cb) {
    	        UI.values.radioSwitchCheckbox[this.id].cb = cb;
    	    }
    	    this.SetMargins = function(l, t, r, b, mode) {
                this.Switch.SetMargins(l, t, r, b, mode);
            }
            this.SetPosition = function(l, t) {
                this.Switch.SetPosition(l, t); 
            }
            this.GetChecked = function() {
                return UI.values.radioSwitchCheckbox[this.id].checked;
            }
            this.SetChecked = function(value) {
                if(!value) {
    	            this.Switch.SetText("[fa-toggle-off]");
    	            this.Switch.SetTextColor("#9e9e9e");
    	            UI.values.radioSwitchCheckbox[this.id].checked = false;
    	        } else {
    	            this.Switch.SetText("[fa-toggle-on]");
    	            this.Switch.SetTextColor(UI.values.radioSwitchCheckbox[this.id].color);
    	            UI.values.radioSwitchCheckbox[this.id].checked = true;
    	        }
            }
    	    
    	    var size = 0.2;
    	    var text = value ? "[fa-toggle-on]" : "[fa-toggle-off]";
    	    var clr = value ? color : "#9e9e9e";
    	    
    	    this.Switch = app.CreateButton(text, null, null, "Fontawesome, Custom");
    	    //this.Switch.SetSize(size*UI.swdp, size*UI.swdp-10, "dp");
    	    this.Switch.SetStyle("#ffffff", "#ffffff", 50, 0, 0, 0);
    	    this.Switch.SetTextSize(25);
    	    this.Switch.SetTextColor(clr);
    	    UI.values.objectIDs[this.Switch.id] = this.id;
    	    this.Switch.SetOnTouch(function() {
    	        var id = UI.values.objectIDs[this.id];
    	        var checked = UI.values.radioSwitchCheckbox[id].checked;
    	        if(checked) {
    	            this.SetText("[fa-toggle-off]");
    	            this.SetTextColor("#9e9e9e");
    	            UI.values.radioSwitchCheckbox[id].checked = false;
    	        } else {
    	            this.SetText("[fa-toggle-on]");
    	            this.SetTextColor(UI.values.radioSwitchCheckbox[id].color);
    	            UI.values.radioSwitchCheckbox[id].checked = true;
    	        }
    	        checked = UI.values.radioSwitchCheckbox[id].checked;
    	        if(UI.values.radioSwitchCheckbox[id].cb) UI.values.radioSwitchCheckbox[id].cb(checked);
    	    });
        }
    },
    
    // ===================== CHECKBOXES ======================
    CreateCheckbox: function(list, width, height, color) {
        return new CheckBox(list, width, height, color);
        function CheckBox(list, width, height, color) {
            this.id = UI.CreateID();
    	    UI.values.radioSwitchCheckbox[this.id] = {cb: null, checkBoxIndexes:[], checkItems: [], checkBox: [],  checkBoxes: []};
    	    
    	    this.SetMargins = function(l, t, r, b, mode) {
                this.Checkbox.SetMargins(l, t, r, b, mode);
            }
            this.SetPosition = function(l, t) {
                this.Checkbox.SetPosition(l, t); 
            }
    	    this.SetOnTouch = function(cb) {
    	        UI.values.radioSwitchCheckbox[this.id].cb = cb;
    	    }
    	    this.GetCheckItem = function() {
    	        var ind = [];
    	        var lst = UI.values.radioSwitchCheckbox[this.id].checkItems;
    	        for(var i = 0; i<lst.length; i++) {
    	            if(lst[i] == true) {
    	               ind.push(i);
    	            }
    	        }
    	        return ind;
    	    }
    	    this.CheckItemByIndex = function(indexes) {
    	        if( !typeof(indexes) ) return null; 
    	        var boxes = UI.values.radioSwitchCheckbox[this.id].checkBox;
    	        if(typeof(indexes) == "object") {
    	            for(var i = 0;  i < indexes.length; i++ ) {
    	               boxes[indexes[i]].SetText("check_box");
    	               UI.values.radioSwitchCheckbox[this.id].checkItems[indexes[i]] = true;
    	            }
    	        } else {
    	            boxes[indexes].SetText("check_box");
    	            UI.values.radioSwitchCheckbox[this.id].checkItems[indexes] = true;
    	        }
    	    }
    	    this.UncheckItemByIndex = function(indexes) {
    	        if( !typeof(indexes) ) return null;
    	        var boxes = UI.values.radioSwitchCheckbox[this.id].checkBox;
    	        if(typeof(indexes) == "object") {
    	            for(var i = 0;  i < indexes.length; i++ ) {
    	               boxes[indexes[i]].SetText("check_box_outline_blank");
    	               UI.values.radioSwitchCheckbox[this.id].checkItems[indexes[i]] = false;
    	            }
    	        } else {
    	            boxes[indexes].SetText("check_box_outline_blank");
    	            UI.values.radioSwitchCheckbox[this.id].checkItems[indexes] = false;
    	        }
    	    }
    	    
    	    var color = color || UI.colors.blue.blue;
    	    var list = list.split(",");
    	    this.Checkbox = app.CreateScroller(width, height);
    	        var lay = app.CreateLayout("Linear", "Left");
    	        lay.SetSize(width, null);
    	        var box = null;
    	        for(var i = 0; i<list.length; i++) {
    	            box = app.CreateLayout("Linear", "Horizontal, Left, VCenter");
    	            box.SetSize(-1, UI.Fr(50));
    	               var checkBox = app.CreateButton("check_box_outline_blank", null, null, "Custom");
    	               checkBox.SetSize(55, 55, "dp");
    	               checkBox.SetMargins(0, 3, 0, 0, "dp");
    	               checkBox.SetTextSize(22);
    	               checkBox.SetStyle("#ffffff", "#ffffff", 50, 0, 0, 0);
    	               checkBox.SetTextColor(color);
    	               checkBox.SetFontFile(UI.fonts.icon);
    	               box.AddChild(checkBox);
    	               
    	               UI.values.objectIDs[checkBox.id] = this.id;
    	               UI.values.radioSwitchCheckbox[this.id].checkBoxIndexes[checkBox.id] = i;
    	               UI.values.radioSwitchCheckbox[this.id].checkItems[i] = false;
    	               UI.values.radioSwitchCheckbox[this.id].checkBox[i] = checkBox;
    	               
    	               checkBox.SetOnTouch(function() {
    	                   var id = UI.values.objectIDs[this.id];
    	                   var index = UI.values.radioSwitchCheckbox[id].checkBoxIndexes[this.id];
    	                   this.GetText() == "check_box" ? this.SetText("check_box_outline_blank") : this.SetText("check_box");
    	                   if(this.GetText() == "check_box") {
    	                       UI.values.radioSwitchCheckbox[id].checkItems[index] = true;
    	                   } else {
    	                       UI.values.radioSwitchCheckbox[id].checkItems[index] = false;
    	                   }
    	                   if(UI.values.radioSwitchCheckbox[id].cb) UI.values.radioSwitchCheckbox[id].cb(index, UI.values.radioSwitchCheckbox[id].checkItems[index]);
    	               });
    	               
    	               var text = app.CreateText( list[i].trim() );
    	               text.SetTextColor("#000000");
    	               text.SetFontFile(UI.fonts.regular);
    	               text.SetTextSize(18);
    	               box.AddChild(text);
    	               /*
    	               UI.values.objectIDs[text.id] = this.id;
    	               UI.values.radioSwitchCheckbox[this.id].checkBoxes[text.id] = checkBox;
    	               text.SetOnTouchDown(function() {
    	                   var id = UI.values.objectIDs[this.id];
    	                   app.SimulateTouch(UI.values.radioSwitchCheckbox[id].checkBoxes[this.id]);
    	               });
    	               */
    	            lay.AddChild(box);
    	        }
    	        this.Checkbox.AddChild(lay);
        }
    },
    
    // ===================== PAGES ===========================
	CreatePage : function(pageTitle, icon, iconPosition, layoutOptions) {
	    return new CreatePage(pageTitle, icon, iconPosition, layoutOptions);
	    function CreatePage(pageTitle, icon, iconPosition, layoutOptions) {
	        this.Page = app.CreateLayout( "Absolute", "FillXY" );	
		    this.Page.SetBackColor(UI.colors.white);
		    	var scroller = app.CreateScroller(null, null);
		    	scroller.SetSize(1, 1);
		    	scroller.SetBackColor(UI.colors.white);
		    		this.Layout = app.CreateLayout("Linear", layoutOptions);
			     	this.Layout.SetSize(1, 1);
			    	this.Layout.SetPadding(0, 55, 0, 0, "dp");
		    		scroller.AddChild(this.Layout);
		    	this.Page.AddChild(scroller);
    	
	    		//var shadow = UI.CreateButtonRaised("", 1.2, 0.095, "#ffffffff");
	    		var shadow = UI.CreateButtonRaised("", 1.2, UI.Fr(55), "#ffffff");
		    	shadow.SetPosition(-0.1, UI.Fr(5));
		    	this.Page.AddChild(shadow);
		    	
		    	var header = app.CreateLayout( "Linear", "VCenter, Left, Horizontal");
		    	header.SetSize(1, UI.Fr(55));
		    	header.SetBackColor(UI.colors.white);
		    		this.Icon = app.CreateButton(icon, null, null, "Custom");
		    		this.Icon.SetTextSize(24, "dp");
			    	this.Icon.SetMargins( 4, 3, 4, 0, "dp");
		    		this.Icon.SetSize(55, 55, "dp");
		    		this.Icon.SetFontFile(UI.fonts.icon);
		    		this.Icon.SetTextColor(UI.colors.black);
		    		this.Icon.SetStyle( "#ffffff", "#ffffff", 50, 0, 0, 0);
		    	
		    		this.PageTitle = app.CreateText(pageTitle, -1, -1, "Left");
		    		this.PageTitle.SetSize(UI.swdp-63, null, "dp");
		    		this.PageTitle.SetTextSize(22);
			    	this.PageTitle.SetFontFile(UI.fonts.bold);
			    	this.PageTitle.SetTextColor("#000000");
			    	this.PageTitle.SetEllipsize("end");
				
			    	if(iconPosition.toLowerCase() == "left") {
			    		header.AddChild(this.Icon);
			    		header.AddChild(this.PageTitle);
			    	} else {
				    	this.PageTitle.SetPadding(25, 0, 10, 0, "dp");
				    	header.AddChild(this.PageTitle);
				    	header.AddChild(this.Icon);
				    }
		    	this.Page.AddChild(header);
	    }
	},
	
	// ===================== NOTES ===========================
	CreateNoteInfo: function(text, icon, clr) {
		return new Note(text, icon, clr);
		function Note(text, icon, clr) {
			this.clr = clr || UI.colors.blue.darken2;
			this.color = UI.CreateLightColor(this.clr);;
			this.Layout = app.CreateLayout("Linear", "Left, Horizontal, FillX");
			this.Layout.SetPadding(25, 25, 25, 0, "dp");
			this.Layout.SetBackColor(this.color);
				this.icon = app.CreateText( icon||"wb_incandescent", null, null, "Left");
				this.icon.SetTextSize(22);
				this.icon.SetTextColor(this.clr);
				this.icon.SetFontFile(UI.fonts.icon);
				this.Layout.AddChild(this.icon);
				
				this.text = app.CreateText(text, null, null, "Left, Multiline, Html");
				this.text.SetTextSize(16);
				this.text.SetFontFile(UI.fonts.regular);
				this.text.SetMargins(15, -10, 0, 25, "dp");
				this.text.SetTextColor(this.clr);
				this.Layout.AddChild(this.text);
			return this.Layout;
		}
	},
	
	// ===================== TABS ============================
	CreateTabFixed: function(titles, width, height, options, color) {
	    return new CreateTabFixed(titles, width, height, options, color);
	    function CreateTabFixed(titles, width, height, options, color) {
		    titles = titles.split(",");
		    color = color || UI.colors.blue.blue;
		    var no = titles.length;
		    var w = width/no;
		    this.Layout = [];
		    this.id = UI.CreateID();
		    UI.values.tabs[this.id] = {tab: [], titleID: [], container: null, callback: null, color: color, lastTouch: null};

		    this.Tab = app.CreateLayout("Absolute");
		    this.Tab.SetSize(width, height);
		        var shadow = app.CreateButton("", null, null, "Custom");
		        shadow.SetStyle("#ffffff", "#ffffff", 0, 0, 0, 1);
		        shadow.SetSize(UI.swdp+40, 50, "dp");
		        shadow.SetPosition(UI.Fw(-10), UI.Fr(7));
		        shadow.SetEnabled(false);
		        
		        var box = app.CreateLayout("Linear", "Horizontal");
		        box.SetSize(width);
		            //add tabs here
		    UI.values.tabs[this.id].container = this.Tab;
		        
		        for(var i=0; i<no; i++) {
		           var con = app.CreateLayout("Linear", "Bottom");
		           con.SetSize(w, UI.Fr(50));
		           
		                var title = app.CreateText(titles[i].trim(), w, null);
		                title.SetTextColor(UI.colors.grey.darken1);
		                title.SetPadding(0, 0, 0, 12, "dp");
		                title.SetFontFile(UI.fonts.medium);
		                con.AddChild(title);
		                UI.values.tabIDs[title.id] = this.id;
		                UI.values.tabs[this.id].titleID[i] = title.id;
		                
		                title.SetOnTouch(function(e) {
		                    var id = UI.values.tabIDs[this.id];
		                    var index = UI.values.tabs[id].titleID.indexOf(this.id);
		                    var border = UI.values.tabs[id].tab[index].border;
		                    var color = UI.values.tabs[id].color;
		                    var con = UI.values.tabs[id].tab[index].con;
		                    var cb = UI.values.tabs[id].callback;
		                    
		                    if(e.action == "Down") con.SetBackColor("#10000000");
							if(e.action == "Move") con.SetBackColor("#00000000");
							if(e.action == "Up") {
								if(cb) cb(this.GetText(), index);
								var lastTouch = UI.values.tabs[id].lastTouch;
		    					if(lastTouch) {
		    					    UI.values.tabs[id].lastTouch.border.SetColor("#00ffffff");
		    					    UI.values.tabs[id].lastTouch.title.SetTextColor(UI.colors.grey.darken1);
		    					    UI.values.tabs[id].lastTouch.layout.Hide();
		    					}
		    					con.SetBackColor("#00000000");
								border.SetColor(color);
								this.SetTextColor(color);
								
								var layout = UI.values.tabs[id].tab[index].layout;
								layout.Show();
		    					UI.values.tabs[id].lastTouch = {
		    					    border: border,
		    					    title: this,
		    					    layout: layout,
		    					};
							}
		                });

		                var border = app.CreateImage(null, null, null, "fix", 1, 1);
				        border.SetSize(w*UI.swdp, 2, "dp");
				        border.SetColor("#00ffffff");
				        con.AddChild(border);
		            box.AddChild(con);
		            
		            var layout = app.CreateLayout("Linear", options);
		            layout.SetPosition(0, UI.Fr(50));
		            layout.SetSize(width, height-UI.Fr(50));
		            layout.Hide();
		            this.Tab.AddChild(layout);
		            this.Layout[titles[i].trim().toLowerCase()] = layout;
		           
		            UI.values.tabs[this.id].tab.push({
		                title: title,
		                border: border,
		                con: con,
		                layout: layout,
		            });
		        }
		        
		        this.Tab.AddChild(shadow);
		        this.Tab.AddChild(box);
		    
		    this.SetOnSelect = function(cb) {
		        UI.values.tabs[this.id].callback = cb;
		    }
		    this.SetActiveTabByIndex = function(index) {
		        var border = UI.values.tabs[this.id].tab[index].border;
		        var color = UI.values.tabs[this.id].color;
		        var con = UI.values.tabs[this.id].tab[index].con;
		        var cb = UI.values.tabs[this.id].callback;
		        
		        con.SetBackColor("#00000000");
				border.SetColor(color);
				UI.values.tabs[this.id].tab[index].title.SetTextColor(color);
				UI.values.tabs[this.id].tab[index].layout.Show();
				if(cb) cb(UI.values.tabs[this.id].tab[index].title.GetText());
				var lastTouch = UI.values.tabs[this.id].lastTouch;
				if(lastTouch) {
				    UI.values.tabs[this.id].lastTouch.border.SetColor("#ffffff");
				    UI.values.tabs[this.id].lastTouch.title.SetTextColor(UI.colors.grey.darken1);
				    UI.values.tabs[this.id].lastTouch.layout.Hide();
				}
				UI.values.tabs[this.id].lastTouch = {
				    border: border,
				    title: UI.values.tabs[this.id].tab[index].title,
				    layout: UI.values.tabs[this.id].tab[index].layout,
				};
		    }
		    this.GetLayout = function(title) {
		       return this.Layout[title.trim().toLowerCase()];
		    }
		    this.SetActiveTabByIndex(0);
		}
	},
	
	// ===================== MENUS ===========================
	CreateMenu: function(list, width, height, position, textColor, type) {
	    return new Menu(list, width, height, position, textColor, type);
	    function Menu(list, width, height, position, textColor, type) {
	        this.id = UI.CreateID();
	        UI.values.menus[this.id] = {layout: null, cb: null};
	        
	        this.SetOnTouch = function(cb) {
	            UI.values.menus[this.id].cb = cb;
	        }
	        
	        var color = "#ffffff";
	        var textColor = textColor || "#000000";
	        if(type && type.toLowerCase() == "dark") {
	            color = "#424242";
	            textColor = "#e0e0e0";
	        }
	        var layout = app.CreateLayout("Linear", "FillXY, "+position);
	        UI.values.objectIDs[layout.id] = this.id;
	        UI.values.menus[this.id].layout = layout;
	        layout.Hide();
	        layout.SetOnTouchUp(function() {
	            var id = UI.values.objectIDs[this.id];
	            app.RemoveLayout(UI.values.menus[id].layout);
	        });
	            var box = app.CreateLayout("Absolute");
	            box.SetSize(0.6, null);
	                var shadow = app.CreateButton("", null, null, "Custom");
	                shadow.SetStyle(color, color, 6, 0, 0, 1);
	                //shadow.SetEnabled(false);
	                box.AddChild(shadow);
	                
	                var menu = app.CreateLayout("Linear", "Left");
	                menu.SetSize(null, height);
	                menu.SetPadding(5, 10, 5, 16, "dp");
	                    var list = app.CreateList(list, null, null);
	                    UI.values.objectIDs[list.id] = this.id;
	                    list.SetFontFile(UI.fonts.regular);
	                    list.SetTextMargins(10, 6, 10, 6, "dp");
	                    list.SetDivider(0, "#00000000");
	                    list.SetTextColor(textColor);
	                    list.SetTextSize(16);
	                    menu.AddChild(list);
	                    list.SetOnTouch(function(a, b, c, d) {
	                        var id = UI.values.objectIDs[this.id];
	                        app.RemoveLayout(UI.values.menus[id].layout);
	                        UI.values.menus[id].cb(a, d);
	                    });
	                box.AddChild(menu);
	            layout.AddChild(box);
	        app.AddLayout(layout);
	        layout.Animate("FadeIn");
	        shadow.SetSize(menu.GetWidth(), menu.GetHeight());
	    }
	    
	},
	
	// ===================== DATE PICKER =====================
	CreateDatePicker: function(color) {
	    return new DatePicker(color);
	    function DatePicker(color) {
	        color = color || UI.colors.teal.teal;
	        
	        this.id = UI.CreateID();
	        var date = new Date();
	        var choosenDate = {
	            yyyy: date.getFullYear(),
	            mm: date.getMonth(),
	            dd: date.getDate()
	        };
	        var currentDate = {
	            yyyy: date.getFullYear(),
	            mm: date.getMonth()
	        };
	        UI.values.datePicker[this.id] = {
	            layout: null,
	            datesLayout: null,
	            title: null,
	            year: null,
	            subtitle: null,
	            cb: null,
	            color: color,
	            dates: [],
	            datesArray: [],
	            choosenDate: choosenDate,
	            currentDate: currentDate,
	            render: function(id, slide) {
    	            var y = UI.values.datePicker[id].currentDate;
    	            var x = UI.values.datePicker[id].choosenDate;
    	            var datesBtn = UI.values.datePicker[id].dates[x.dd];
    	            datesBtn.SetStyle("#ffffff", "#ffffff", 38, 0, 0, 0);
                    datesBtn.SetTextColor("#000000");   
    	            UI.values.datePicker[id].dates = [];
    	            var day = 1;
    	            UI.values.datePicker[id].datesLayout.Hide();
    	            UI.values.datePicker[id].datesArray.map(function(item, i) {
    	                item.Hide();
    	                var x = UI.values.datePicker[UI.values.datePickerID].currentDate;
    	                var date = new Date(x.yyyy, x.mm, day);
    	                if(i<7 && date.getDay()== i) {
    	                    item.SetText(day);
    	                    item.Show();
                            UI.values.datePicker[UI.values.datePickerID].dates[day] = item;
                            day++;
    	                } else if(i>6 && date.getMonth() == x.mm) {
    	                    item.SetText(day);
    	                    item.Show();
                            UI.values.datePicker[UI.values.datePickerID].dates[day] = item;
                            day++;
    	                }
    	            });
    	            UI.values.datePicker[id].datesLayout.Animate(slide);
                    if(x.mm == y.mm && x.yyyy == y.yyyy) {
                        var color = UI.values.datePicker[id].color;
                        datesBtn = UI.values.datePicker[id].dates[x.dd];
                        datesBtn.SetStyle(color, color, 38, 0, 0, 0);
                        datesBtn.SetTextColor("#ffffff");
                    }
	            }
	        };
	        
	        this.SetOnSelect = function(cb) {
	            UI.values.datePicker[this.id].cb = cb;
	        }
	        var width = UI.Fw(310);
	        var lay = app.CreateLayout("Linear", "FillXY, VCenter");
	        UI.values.datePicker[this.id].layout = lay;
	        lay.SetBackColor("#88000000");
                var layout = app.CreateLayout("Linear", "left");
                layout.SetSize(width, null);
                layout.SetBackColor("#ffffff");
                    var layTop = app.CreateLayout("Linear", "Left, VCenter");
                    layTop.SetBackColor(color);
                    layTop.SetSize(width, UI.Fr(100));
                    layTop.SetPadding(25, 0, 25, 0, "dp");
                        var year = UI.CreateTextH6(date.getFullYear(), null, null, "Left", "#ffffff");
                        layTop.AddChild(year);
                        UI.values.datePicker[this.id].year = year;
                        
                        var newDate = new Date(date.getFullYear(), date.getMonth(), date.getDate()).toDateString().split(" ");
                        var title = UI.CreateTextH2(newDate[0]+", "+newDate[1]+" "+newDate[2], null, null, "Left", "#ffffff", "Medium");
                        layTop.AddChild(title);
                        UI.values.datePicker[this.id].title = title;
                        
                    layout.AddChild(layTop);
                    
                    var monYearLay = app.CreateLayout("Linear", "Horizontal, VCenter");
                    monYearLay.SetSize(width, UI.Fr(60));
                        var prevMonBtn = app.CreateButton("keyboard_arrow_left", null, null, "Custom");
                        prevMonBtn.SetStyle("#ffffff", "#ffffff", 50, 0, 0, 0);
                        prevMonBtn.SetSize(50, 50, "dp");
                        prevMonBtn.SetTextSize(24);
                        prevMonBtn.SetMargins(0, 5, 0, 0, "dp");
                        prevMonBtn.SetTextColor("#000000");
                        prevMonBtn.SetFontFile(UI.fonts.icon);
                        monYearLay.AddChild(prevMonBtn);
                        UI.values.objectIDs[prevMonBtn.id] = this.id;
                        prevMonBtn.SetOnTouch(function() {
                            var id = UI.values.objectIDs[this.id];
                            var x = UI.values.datePicker[id].currentDate;
                            x.mm -= 1;
                            if(x.mm < 0) {
                                x.mm = 11;
                                x.yyyy -= 1;
                            }
                            UI.values.datePicker[id].subtitle.SetText(UI.values.months[x.mm]+" "+x.yyyy);
                            UI.values.datePickerID = id;
                            UI.values.datePicker[id].render(id, "SlideFromLeft");
                        });
                        
                        var subtitle = UI.CreateTextParagraph(UI.values.months[date.getMonth()]+" "+date.getFullYear());
                        subtitle.SetSize(width-UI.Fw(120));
                        monYearLay.AddChild(subtitle);
                        UI.values.datePicker[this.id].subtitle = subtitle;
                        
                        var nextMonBtn = app.CreateButton("keyboard_arrow_right", null, null, "Custom");
                        nextMonBtn.SetStyle("#ffffff", "#ffffff", 50, 0, 0, 0);
                        nextMonBtn.SetSize(50, 50, "dp");
                        nextMonBtn.SetTextSize(24);
                        nextMonBtn.SetMargins(0, 5, 0, 0, "dp");
                        nextMonBtn.SetTextColor("#000000");
                        nextMonBtn.SetFontFile(UI.fonts.icon);
                        monYearLay.AddChild(nextMonBtn);
                        UI.values.objectIDs[nextMonBtn.id] = this.id;
                        nextMonBtn.SetOnTouch(function() {
                            var id = UI.values.objectIDs[this.id];
                            var x = UI.values.datePicker[id].currentDate;
                            x.mm += 1;
                            if(x.mm > 11) {
                                x.mm = 0;
                                x.yyyy += 1;
                            }
                            UI.values.datePicker[id].subtitle.SetText(UI.values.months[x.mm]+" "+x.yyyy);
                            UI.values.datePickerID = id;
                            UI.values.datePicker[id].render(id, "SlideFromRight");
                        });
                    layout.AddChild(monYearLay);
                    
                    var body = app.CreateLayout("Linear");
                    body.SetSize(width, null);
                        var layDays = app.CreateLayout("Linear", "Horizontal");
                        layDays.SetMargins(0, 0, 0, 30, "dp");
                            var DI, days = ["S", "M", "T", "W", "T", "F", "S"];
                            for(var i = 0; i < 7; i++) {
                                DI = UI.CreateTextSecondary(days[i], UI.Fw(39), null, "Center", UI.colors.grey.darken1, "Regular");
                                layDays.AddChild(DI);
                            }
                        body.AddChild(layDays);
                        
                        var datesLayout = app.CreateLayout("Linear");
                        UI.values.datePicker[this.id].datesLayout = datesLayout;
                        
                            var x = UI.values.datePicker[this.id].currentDate;
                            var day = 1, dt = "";
                            
                            for(var i = 0; i < 6; i++) {
                                var layDays = app.CreateLayout("Linear", "Horizontal");
                                var daysBtn;
                                for(var j = 0; j<7; j++) {
                                    var dayOfTheWeek = new Date(x.yyyy, x.mm, day).getDay();
                                    var monthOfTheDate = new Date(x.yyyy, x.mm, day).getMonth();
                                    if( ( (day/7).toFixed(0) == i && dayOfTheWeek == j) || ( i>0 && monthOfTheDate == x.mm) ) {
                                        dt = day;
                                        day++;
                                    } else if(monthOfTheDate > x.mm){
                                        dt = "";
                                    }
                                    daysBtn = app.CreateButton( dt, null, null, "Custom");
                                    daysBtn.SetSize(45, 45, "dp");
                                    daysBtn.SetMargins(-3, -2, -3, -2.5, "dp");
                                    daysBtn.SetTextColor("#000000");
                                    daysBtn.SetTextSize(13, "dp");
                                    daysBtn.SetStyle("#ffffff", "#ffffff", 38, 0, 0, 0);
                                    layDays.AddChild(daysBtn);
                                    if(dt=="") daysBtn.Hide();
                                    UI.values.datePicker[this.id].dates[dt] = daysBtn;
                                    UI.values.datePicker[this.id].datesArray[(i*7)+j] = daysBtn;
                                    if(UI.values.datePicker[this.id].choosenDate.dd == dt) {
                                        daysBtn.SetStyle(color, color, 38, 0, 0, 0);
                                        daysBtn.SetTextColor("#ffffff");
                                    }
                                    UI.values.objectIDs[daysBtn.id] = this.id;
                                    daysBtn.SetOnTouch(function() {
                                        var id = UI.values.objectIDs[this.id];
                                        var color = UI.values.datePicker[id].color;
                                        this.SetStyle(color, color, 38, 0, 0, 0);
                                        this.SetTextColor("#ffffff");
                                        var choosenDate = UI.values.datePicker[id].choosenDate;
                                        var datesBtn = UI.values.datePicker[id].dates[choosenDate.dd];
                                        datesBtn.SetStyle("#ffffff", "#ffffff", 38, 0, 0, 0);
                                        datesBtn.SetTextColor("#000000");
                                        UI.values.datePicker[id].choosenDate.yyyy = UI.values.datePicker[id].currentDate.yyyy;
                                        UI.values.datePicker[id].choosenDate.mm = UI.values.datePicker[id].currentDate.mm;
                                        UI.values.datePicker[id].choosenDate.dd = this.GetText();
                                        var newDate = new Date(choosenDate.yyyy, choosenDate.mm, choosenDate.dd).toDateString().split(" ");
                                        UI.values.datePicker[id].title.SetText(newDate[0]+", "+newDate[1]+" "+newDate[2]);
                                        UI.values.datePicker[id].year.SetText(UI.values.datePicker[id].choosenDate.yyyy);
                                    });
                                }
                                datesLayout.AddChild(layDays);
                            }
                            body.AddChild(datesLayout);
                    layout.AddChild(body);
                    
                    var layBottom = app.CreateLayout("Linear", "Horizontal, Right, VCenter");
                    layBottom.SetSize(width, UI.Fr(60));
                    layBottom.SetPadding(20, 0, 12, 0, "dp");
                        var closeBtn = UI.CreateButtonFlat("CANCEL", null, null, color);
                        layBottom.AddChild(closeBtn);
                        UI.values.objectIDs[closeBtn.id] = this.id;
                        closeBtn.SetOnTouch(function() {
                            var id = UI.values.objectIDs[this.id];
                            UI.values.datePicker[id].layout.Hide();
                            app.DestroyLayout(UI.values.datePicker[id].layout);
                            UI.values.datePicker[id] = null;
                        });
                        
                        var okBtn = UI.CreateButtonFlat("OK", null, null, color);
                        layBottom.AddChild(okBtn);
                        UI.values.objectIDs[okBtn.id] = this.id;
                        okBtn.SetOnTouch(function() {
                            var id = UI.values.objectIDs[this.id];
                            var cb = UI.values.datePicker[id].cb;
                            if(cb) {
                                var date = UI.values.datePicker[id].choosenDate;
                                cb(date.yyyy+"-"+date.mm+"-"+date.dd);
                            }
                            UI.values.datePicker[id].layout.Hide();
                            app.DestroyLayout(UI.values.datePicker[id].layout);
                            UI.values.datePicker[id] = null;
                        });
                    layout.AddChild(layBottom);
                lay.AddChild(layout);
	        app.AddLayout(lay);
	    }
	},
	
	// ===================== DATE PICKER =====================
	CreateTimePicker: function(hh, mm, color) {
	    return new TimePicker(hh, mm, color);
	    function TimePicker(hh, mm, color) {
	        color = color || "#009688";
	        
	        this.id = UI.CreateID();
	        UI.values.timePicker[this.id] = {
	            color: color,
	            layout: null,
	            cancelBtn: null,
	            okBtn: null,
	            clockIsHour: true,
	            cb: null,
	            hhText: null,
	            mmText: null,
	            amText: null,
	            pmText: null,
	            backClock: null,
	            frontClock: null,
	            chosenTime: {
	                hh: null,
	                mm: null,
	                pos: null
	            }
	        };
	        
	        this.SetOnSelect = function(cb) {
	            UI.values.timePicker[this.id].cb = cb;
	        }
	        
	        var width = UI.Fw(300);
	        var date = new Date();
	        var hour = hh || date.getHours();
	        var minutes = mm || date.getMinutes();
	        
	        var isAM = true;
	        if(hour > 12) {
	            isAM = false;
	            hour = hour - 12;
	        }
	        if(hour < 10) hour = "0"+hour;
	        if(minutes<10) minutes = "0"+minutes;
	        if(isAM) UI.values.timePicker[this.id].chosenTime.pos = "AM";
	        else UI.values.timePicker[this.id].chosenTime.pos = "PM";
	        
	       // var angle = 450 - (hour * (360/12));
	       // angle = angle*(Math.PI/180);
	        
	        UI.values.timePicker[this.id].chosenTime.hh = hour;
	        UI.values.timePicker[this.id].chosenTime.mm = minutes;
	        
	        var layout = app.CreateLayout("Linear", "FillXY, VCenter");
	        UI.values.timePicker[this.id].layout = layout;
	        layout.data.id = this.id;
	        layout.SetBackColor("#88000000");
	            var box = app.CreateLayout("Linear");
	            box.SetBackColor("#ffffff");
	            box.SetSize(width, null);
	                var layTop = app.CreateLayout("Linear", "Horizontal, VCenter");
	                layTop.SetSize(width, UI.Fr(100));
	                layTop.SetBackColor(color);
	                layTop.SetMargins(0, 0, 0, 20, "dp");
	                    var hhText = app.CreateText(hour+":");
                        hhText.SetTextColor("#ffffff");
                        hhText.SetTextSize(50);
                        hhText.SetFontFile(UI.fonts.regular);
                        layTop.AddChild(hhText);
                        UI.values.timePicker[this.id].hhText = hhText;
                        
                        var mmText = app.CreateText(minutes);
                        mmText.SetTextColor("#ffffff");
                        mmText.SetTextSize(50);
                        mmText.SetFontFile(UI.fonts.regular);
                        layTop.AddChild(mmText);
                        UI.values.timePicker[this.id].mmText = mmText;
                        
                        var lay1 = app.CreateLayout("Linear");
                        lay1.SetMargins(10, 0, 0, 0, "dp");
                            var amText = UI.CreateTextParagraph("AM", null, null, "Left", UI.colors.grey.lighten1, "Medium");
                            amText.SetMargins(0, 0, 0, 5, "dp");
                            lay1.AddChild(amText);
                            UI.values.objectIDs[amText.id] = this.id;
                            UI.values.timePicker[this.id].amText = amText;
                            amText.SetOnTouchUp(function() {
                                var id = UI.values.objectIDs[this.id];
                                var pos = UI.values.timePicker[id].chosenTime.pos;
                                if(pos != "AM") {
                                    this.SetTextColor("#ffffff");
                                    UI.values.timePicker[id].pmText.SetTextColor(UI.colors.grey.lighten1);
                                    UI.values.timePicker[id].chosenTime.pos = "AM";
                                }
                                UI.values.timePicker[id].chosenTime.pos = "AM";
                            });
                            
                            var pmText = UI.CreateTextParagraph("PM", null, null, "Left", UI.colors.grey.lighten1, "Medium");
                            lay1.AddChild(pmText);
                            UI.values.objectIDs[pmText.id] = this.id;
                            UI.values.timePicker[this.id].pmText = pmText;
                            pmText.SetOnTouchUp(function() {
                                var id = UI.values.objectIDs[this.id];
                                var pos = UI.values.timePicker[id].chosenTime.pos;
                                if(pos != "PM") {
                                    this.SetTextColor("#ffffff");
                                    UI.values.timePicker[id].amText.SetTextColor(UI.colors.grey.lighten1);
                                    UI.values.timePicker[id].chosenTime.pos = "PM";
                                }
                                UI.values.timePicker[id].chosenTime.pos = "PM";
                            });
                            if(isAM) amText.SetTextColor("#ffffff");
                            else pmText.SetTextColor("#ffffff");
                        layTop.AddChild(lay1);
	                box.AddChild(layTop);
	                
	                var body = app.CreateLayout("Absolute");
	                    var backClock = app.CreateImage(null, UI.Fw(252), UI.Fr(252));
	                    body.AddChild(backClock);
	                    UI.values.timePicker[this.id].backClock = backClock;
	                    backClock.SetAutoUpdate(false);
	                    
	                    var frontClock = app.CreateImage(null, UI.Fw(252), UI.Fr(252));
    	                body.AddChild(frontClock);
    	                UI.values.timePicker[this.id].frontClock = frontClock;
    	                frontClock.SetAutoUpdate(false);
    	                frontClock.SetPaintColor("#000000");
	                    frontClock.SetTextSize(14); 
    	                frontClock.data.id = this.id;
    	                UI.functions.RenderHour(this.id);
    	                frontClock.SetOnTouch(function(e) {
    	                    var id = this.data.id;
    	                    var angle = Math.atan((0.5-e.Y)/(e.X-0.5));
                            if(e.X<0.5) angle += Math.PI;
                            if(angle<0) angle += (2*Math.PI);
                            if(UI.values.timePicker[id].clockIsHour === true) angle = UI.functions.CheckClockTouchAngleHour(angle, id); 
                            else {
                                var min = UI.values.timePicker[id].mmText;
                                var mm = 75 - ( (0.5*angle/Math.PI) * 60 ).toFixed(0);
                                if(mm > 59) mm -= 60;
                                if(mm < 10) mm = "0"+mm;
                                min.SetText(mm);
                                UI.values.timePicker[id].chosenTime.mm = mm;
                            }
                            
                            var backClock = UI.values.timePicker[id].backClock;
                            backClock.Clear();
                            backClock.SetPaintColor(UI.colors.grey.lighten2);
        	                backClock.DrawCircle(0.5, 0.5, 0.5);
        	                backClock.SetPaintColor(color);
        	                backClock.DrawCircle(0.5, 0.5, 0.0125);
    	                    if(e.action == "Move") {
            	                backClock.SetPaintColor(color);
        	                    backClock.SetLineWidth(2);
            	                backClock.DrawLine(0.5, 0.5, 0.5+0.45*Math.cos(angle), 0.5-0.45*Math.sin(angle));
            	                backClock.DrawCircle(0.5+0.425*Math.cos(angle), 0.5-0.425*Math.sin(angle), 0.07);
            	                backClock.Update();
    	                    }
    	                    else if(e.action == "Up") {
            	                backClock.SetPaintColor(color);
        	                    backClock.SetLineWidth(2);
            	                backClock.DrawLine(0.5, 0.5, 0.5+0.45*Math.cos(angle), 0.5-0.45*Math.sin(angle));
            	                backClock.DrawCircle(0.5+0.425*Math.cos(angle), 0.5-0.425*Math.sin(angle), 0.07);
            	                backClock.Update();
    	                    }
    	                });
	                
	                box.AddChild(body);
	                
	                var layBottom = app.CreateLayout("Linear", "Horizontal, Right, VCenter");
                    layBottom.SetSize(width, UI.Fr(60));
                    layBottom.SetPadding(20, 0, 12, 0, "dp");
                        var closeBtn = UI.CreateButtonFlat("CANCEL", null, null, color);
                        layBottom.AddChild(closeBtn);
                        UI.values.objectIDs[closeBtn.id] = this.id;
                        UI.values.timePicker[this.id].cancelBtn = closeBtn;
                        closeBtn.SetOnTouch(function() {
                            var id = UI.values.objectIDs[this.id];
                            if(this.GetText() === "CANCEL") {
                                UI.values.timePicker[id].layout.Hide();
                                app.DestroyLayout(UI.values.timePicker[id].layout);
                                UI.values.timePicker[id] = null;
                            } else {
                                this.SetText("CANCEL");
                                UI.values.timePicker[id].okBtn.SetText("NEXT");
                                UI.functions.RenderHour(id);
                                UI.values.timePicker[id].clockIsHour = true;
                            }
                        });
                        
                        var okBtn = UI.CreateButtonFlat("NEXT", null, null, color);
                        layBottom.AddChild(okBtn);
                        UI.values.objectIDs[okBtn.id] = this.id;
                        UI.values.timePicker[this.id].okBtn = okBtn;
                        okBtn.SetOnTouch(function() {
                            var id = UI.values.objectIDs[this.id];
                            var cb = UI.values.timePicker[id].cb;
                            if(this.GetText() === "OK" && cb) {
                                var hh = UI.values.timePicker[id].chosenTime.hh;
                                var mm = UI.values.timePicker[id].chosenTime.mm;
                                var pos = UI.values.timePicker[id].chosenTime.pos;
                                UI.values.timePicker[id].layout.Hide();
                                app.DestroyLayout(UI.values.timePicker[id].layout);
                                UI.values.timePicker[id] = null;
                                cb(hh+":"+mm+" "+pos); 
                            } else if( this.GetText() === "OK" && cb == null ) {
                                UI.values.timePicker[id].layout.Hide();
                                app.DestroyLayout(UI.values.timePicker[id].layout);
                                UI.values.timePicker[id] = null;
                            } else {
                                this.SetText("OK");
                                UI.values.timePicker[id].cancelBtn.SetText("BACK");
                                UI.functions.RenderMinutes(id);
                                UI.values.timePicker[id].clockIsHour = false;
                            }
                        });
                    box.AddChild(layBottom);
	            layout.AddChild(box);
	        app.AddLayout(layout);
	        layout.SetOnTouchUp(function() {
	            UI.values.timePicker[this.data.id] = null;
	            app.DestroyLayout(this);
	        });
	    }
	},
	
	// ===================== CARDS ===========================
    CreateCard: function(width, height, color, radius) {
        return new Card(width, height, color, radius);
        function Card(width, height, color, radius) {
            
            color = color || "#ffffff";
            this.Card = app.CreateLayout("Absolute");
                var background = app.CreateButton("", width, height, "Custom");
                background.SetStyle(color, color, radius, 0, 0, 1);
                background.SetEnabled(false);
                this.Card.AddChild(background);
                
                this.Layout = app.CreateLayout("Linear", "Left");
                this.Layout.SetSize(width-UI.Fw(10), height-UI.Fr(10));
                this.Layout.SetPosition(UI.Fw(5), UI.Fr(2.5));
                
                this.Card.AddChild(this.Layout);
        }
    },
	
	//====================== DIVIDER =========================
	CreateDivider : function (px) {
		return new Divider(px);
		function Divider(px) {
			this.px = px || 2;
			this.s = app.CreateImage(null, null, null, "fix", 1, 1);
			this.s.SetSize(UI.sw, this.px, "px" );
			this.s.SetColor( UI.colors.grey.lighten2 );
			return this.s;
		}
	},
	
	// ===================== MISCELLANEOUS METHODS ===========
	DpToPx : function( dp ) {
		return (this.dp*dp)/160;
	},
	Fr: function(dp) {
		return ((this.dp*dp)/160)/this.sh;
	},
	Fw: function(dp) {
		return ((this.dp*dp)/160)/this.sw;
	},
	CreateID: function() {
		var id = Math.floor( Math.random() * 1000000 );
		var b = UI.values.IDs[id];
		if( !b ) {
		    UI.values.IDs.push(id);
		    return id;
		}
		else this.CreateListId();
	},
	CreateLightColor: function(color) {
		if(color.length==7) color = color.replace("#", "#ff");
		color = color.replace("#ff", "#40");
		return color;
	},
	RemoveLayout: function() {
        var layout = UI.values.layoutToRemove;
        if(layout) {
            layout.Animate("SlideToTop");
            app.DestroyLayout(layout);    
            UI.values.layoutToRemove = null;
        }
    }
};